#include "XC3dWaveprop.h"
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
// 2nd order in time
// 4nd order in space
// no boundary condition
int XC3dWaveprop_1step2t10spaceopt2(float *veldtinvdx2, int izmin, int izmax, int ixmin, int ixmax, int iymin, int iymax, \
                                            int XC3dWaveprop_nxtape, int XC3dWaveprop_nytape, int XC3dWaveprop_nztape, \
                                            int XC3dWaveprop_nx, int XC3dWaveprop_ny, int XC3dWaveprop_nz, \
   	                                    float *XC3dWaveprop_wavet1, float *XC3dWaveprop_wavet2, float *XC3dWaveprop_wavet3, \
                                            float *XC3dWaveprop_tmpwv)
{
  int fat,fat2,curidx;
  int ix,iy,iz,i,iz0;
  int iz1,iz2;
  int ix1,ix2;
  int iy1,iy2;
  int ctrx,ctry,ctrz;
  fat=5;
  fat2=5;

  float temp1;
  float* wvt1;
  float* wvt2;
  float* wvt3;
  float* tmpwv;
  wvt1=XC3dWaveprop_wavet1;
  wvt2=XC3dWaveprop_wavet2;
  wvt3=XC3dWaveprop_wavet3;
  tmpwv=XC3dWaveprop_tmpwv;
  
  int nx,ny,nz;
  nx=XC3dWaveprop_nx;
  ny=XC3dWaveprop_ny;
  nz=XC3dWaveprop_nz;
  int inciz=1;
  int incix=nz;
  int inciy=nz*nx;
  int nxtape,nytape,nztape;
  nxtape=XC3dWaveprop_nxtape;
  nytape=XC3dWaveprop_nytape;
  nztape=XC3dWaveprop_nztape;

  iz1=max(0+fat,izmin-fat);
  iz2=min(nz-fat,izmax+fat);
  ix1=max(0+fat,ixmin-fat);
  ix2=min(nx-fat,ixmax+fat);
  iy1=max(0+fat,iymin-fat);
  iy2=min(ny-fat,iymax+fat);

  float a[11];

  a[0]=1./3150.;
  a[1]=-5./1008.;
  a[2]=5./126.;
  a[3]=-5./21.;
  a[4]=5./3.;
  a[5]=(a[0]+a[1]+a[2]+a[3]+a[4])*(-2.);
  a[6]=5./3.;
  a[7]=-5./21.;
  a[8]=5./126.;
  a[9]=-5./1008.;
  a[10]=1./3150.;

     
  float a1=5./3.;
  float a2=-5./21.;
  float a3=5./126.;
  float a4=-5./1008.;
  float a5=1./3150.;
  float a0=a1+a2+a3+a4+a5;
  float curv,scurv;
  float curval,outval;
  float tpwht=0.25f;
     //#pragma omp parallel for private(iybegpad,iyendpad,whtybegpad,whtyendpad,izbegpad,izendpad,whtzbegpad,whtzendpad,ixbegpad,ixendpad,whtxbegpad,whtxendpad,curidx,curval,temp1,outval) schedule(dynamic,8)

     //#pragma omp parallel for private(curidx,curval,temp1,outval,ix,iz,iy) schedule(dynamic,8)
 
  for (iy=iy1;iy<iy2;iy++)
  {
     #pragma omp parallel for private(ix,iz,temp1) schedule(dynamic,8)
     for (ix=ix1;ix<ix2;ix++)
     {  
        for (iz=iz1;iz<iz2;iz++)
        {
           //curidx=Wpzxyloc(iz,ix,iy);
           temp1 = a5*(wvt2[ Wpzxyloc(iz-5,ix,iy) ] + wvt2[ Wpzxyloc(iz+5,ix,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix-5,iy) ] + wvt2[ Wpzxyloc(iz,ix+5,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix,iy-5) ] + wvt2[ Wpzxyloc(iz,ix,iy+5) ] ) ;
           temp1+= a4*(wvt2[ Wpzxyloc(iz-4,ix,iy) ] + wvt2[ Wpzxyloc(iz+4,ix,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix-4,iy) ] + wvt2[ Wpzxyloc(iz,ix+4,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix,iy-4) ] + wvt2[ Wpzxyloc(iz,ix,iy+4) ] ) ;
           temp1+= a3*(wvt2[ Wpzxyloc(iz-3,ix,iy) ] + wvt2[ Wpzxyloc(iz+3,ix,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix-3,iy) ] + wvt2[ Wpzxyloc(iz,ix+3,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix,iy-3) ] + wvt2[ Wpzxyloc(iz,ix,iy+3) ] ) ;
           temp1+= a2*(wvt2[ Wpzxyloc(iz-2,ix,iy) ] + wvt2[ Wpzxyloc(iz+2,ix,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix-2,iy) ] + wvt2[ Wpzxyloc(iz,ix+2,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix,iy-2) ] + wvt2[ Wpzxyloc(iz,ix,iy+2) ] ) ;
           temp1+= a1*(wvt2[ Wpzxyloc(iz-1,ix,iy) ] + wvt2[ Wpzxyloc(iz+1,ix,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix-1,iy) ] + wvt2[ Wpzxyloc(iz,ix+1,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix,iy-1) ] + wvt2[ Wpzxyloc(iz,ix,iy+1) ] ) ;
           /* 
           temp1 = a5*(wvt2[ Wpzxyloc(iz-5,ix,iy) ] + wvt2[ Wpzxyloc(iz+5,ix,iy) ] ) ;
           temp1+= a5*(wvt2[ Wpzxyloc(iz,ix-5,iy) ] + wvt2[ Wpzxyloc(iz,ix+5,iy) ] ) ;
           temp1+= a5*(wvt2[ Wpzxyloc(iz,ix,iy-5) ] + wvt2[ Wpzxyloc(iz,ix,iy+5) ] ) ;
           temp1+= a4*(wvt2[ Wpzxyloc(iz-4,ix,iy) ] + wvt2[ Wpzxyloc(iz+4,ix,iy) ] ) ;
           temp1+= a4*(wvt2[ Wpzxyloc(iz,ix-4,iy) ] + wvt2[ Wpzxyloc(iz,ix+4,iy) ] ) ;
           temp1+= a4*(wvt2[ Wpzxyloc(iz,ix,iy-4) ] + wvt2[ Wpzxyloc(iz,ix,iy+4) ] ) ;
           temp1+= a3*(wvt2[ Wpzxyloc(iz-3,ix,iy) ] + wvt2[ Wpzxyloc(iz+3,ix,iy) ] ) ;
           temp1+= a3*(wvt2[ Wpzxyloc(iz,ix-3,iy) ] + wvt2[ Wpzxyloc(iz,ix+3,iy) ] ) ; 
           temp1+= a3*(wvt2[ Wpzxyloc(iz,ix,iy-3) ] + wvt2[ Wpzxyloc(iz,ix,iy+3) ] ) ;
           temp1+= a2*(wvt2[ Wpzxyloc(iz-2,ix,iy) ] + wvt2[ Wpzxyloc(iz+2,ix,iy) ] ) ;
           temp1+= a2*(wvt2[ Wpzxyloc(iz,ix-2,iy) ] + wvt2[ Wpzxyloc(iz,ix+2,iy) ] ) ;
           temp1+= a2*(wvt2[ Wpzxyloc(iz,ix,iy-2) ] + wvt2[ Wpzxyloc(iz,ix,iy+2) ] ) ;
           temp1+= a1*(wvt2[ Wpzxyloc(iz-1,ix,iy) ] + wvt2[ Wpzxyloc(iz+1,ix,iy) ] ) ;
           temp1+= a1*(wvt2[ Wpzxyloc(iz,ix-1,iy) ] + wvt2[ Wpzxyloc(iz,ix+1,iy) ] ) ;
           temp1+= a1*(wvt2[ Wpzxyloc(iz,ix,iy-1) ] + wvt2[ Wpzxyloc(iz,ix,iy+1) ] ) ;*/
           temp1+= -6.0*a0*wvt2[Wpzxyloc(iz,ix,iy)];
           wvt3[Wpzxyloc(iz,ix,iy)] = 2.0*wvt2[Wpzxyloc(iz,ix,iy)]- wvt1[Wpzxyloc(iz,ix,iy)] + temp1*veldtinvdx2[Wpzxyloc(iz,ix,iy)];
        }
     }
  }   
  
  return 0; 
}
