///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
// 2nd order in time
// 4nd order in space
// no boundary condition
int XC3dWaveprop_1step2t4space(float *veldtinvdx2, int izmin, int izmax)
{
  int fat,curidx;
  int ix,iy,iz;
  int iz1,iz2;
  fat=5;

  float temp1,curval;
  float *wvt1,*wvt2,*wvt3;
  wvt1=XC3dWaveprop_wavet1;
  wvt2=XC3dWaveprop_wavet2;
  wvt3=XC3dWaveprop_wavet3;
  
  int nx,ny,nz;
  nx=XC3dWaveprop_nx;
  ny=XC3dWaveprop_ny;
  nz=XC3dWaveprop_nz;

  iz1=max(0+fat,izmin-fat);
  iz2=min(nz-fat,izmax+fat);

  float a3=-1./12.;
  float a2=16./12.;
  float a1=1.25f;
  for (iy=0+fat;iy<ny-fat;iy++)
  {
     #pragma omp parallel for private(curidx,curval,temp1) schedule(dynamic,8)
     for (ix=0+fat;ix<nx-fat;ix++)
        for (iz=iz1;iz<iz2;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt2[ curidx ];
          temp1= a3*wvt2[ Wpzxyloc(iz-2,ix,iy) ] + a2*wvt2[ Wpzxyloc(iz-1,ix,iy) ] - 6.0*a1*curval + a2*wvt2[ Wpzxyloc(iz+1,ix,iy) ] + a3*wvt2[ Wpzxyloc(iz+2,ix,iy) ] \
                +a3*wvt2[ Wpzxyloc(iz,ix-2,iy) ] + a2*wvt2[ Wpzxyloc(iz,ix-1,iy) ] + a2*wvt2[ Wpzxyloc(iz,ix+1,iy) ] + a3*wvt2[ Wpzxyloc(iz,ix+2,iy) ] \ 
                +a3*wvt2[ Wpzxyloc(iz,ix,iy-2) ] + a2*wvt2[ Wpzxyloc(iz,ix,iy-1) ] + a2*wvt2[ Wpzxyloc(iz,ix,iy+1) ] + a3*wvt2[ Wpzxyloc(iz,ix,iy+2) ];
          wvt1[curidx]  = 2.0*curval- wvt1[curidx] +temp1*veldtinvdx2[curidx];
        }   
   }
   return 0;
}
