///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
// 2nd order in time
// 4nd order in space
// no boundary condition
int XC3dWaveprop_1step4t10spaceopt(float *veldtinvdx2, int izmin, int izmax)
{
  int fat,fat2,curidx;
  int ix,iy,iz;
  int iz1,iz2;
  fat=5;
  fat2=5;

  float temp1;
  float *wvt1,*wvt2,*wvt3;
  wvt1=XC3dWaveprop_wavet1;
  wvt2=XC3dWaveprop_wavet2;
  wvt3=XC3dWaveprop_wavet3;
  
  int nx,ny,nz;
  nx=XC3dWaveprop_nx;
  ny=XC3dWaveprop_ny;
  nz=XC3dWaveprop_nz;
  int nxtape,nytape,nztape;
  nxtape=XC3dWaveprop_nxtape;
  nytape=XC3dWaveprop_nytape;
  nztape=XC3dWaveprop_nztape;

  iz1=max(0+fat,izmin-fat);
  iz2=min(nz-fat,izmax+fat);

  float a5=1./3150.;
  float a4=-5./1008.;
  float a3=5./126.;
  float a2=-5./21.;
  float a1=5./3.;
  float a0=a1+a2+a3+a4+a5;

  
  float curv,scurv;
  float curval,outval;
  float tpwht=0.25f;
     //#pragma omp parallel for private(iybegpad,iyendpad,whtybegpad,whtyendpad,izbegpad,izendpad,whtzbegpad,whtzendpad,ixbegpad,ixendpad,whtxbegpad,whtxendpad,curidx,curval,temp1,outval) schedule(dynamic,8)

     //#pragma omp parallel for private(curidx,curval,temp1,outval,ix,iz,iy) schedule(dynamic,8)
  for (iy=0+fat;iy<ny-fat;iy++)
  {

     #pragma omp parallel for private(curidx,curval,temp1,outval,ix,iz) schedule(dynamic,8)
     for (ix=0+fat;ix<nx-fat;ix++)
     {
        
        //#pragma omp parallel for private(curidx,curval,temp1,outval) schedule(dynamic,8)
        for (iz=iz1;iz<iz2;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt2[curidx];
          temp1= a5*wvt2[ Wpzxyloc(iz-5,ix,iy) ] +   a4*wvt2[ Wpzxyloc(iz-4,ix,iy) ] + a3*wvt2[ Wpzxyloc(iz-3,ix,iy) ] + a2*wvt2[ Wpzxyloc(iz-2,ix,iy) ] + a1*wvt2[ Wpzxyloc(iz-1,ix,iy) ] - 6.0*a0*curval + a1*wvt2[ Wpzxyloc(iz+1,ix,iy) ] + a2*wvt2[ Wpzxyloc(iz+2,ix,iy) ] + a3*wvt2[ Wpzxyloc(iz+3,ix,iy) ] + a4*wvt2[ Wpzxyloc(iz+4,ix,iy) ] + a5*wvt2[ Wpzxyloc(iz+5,ix,iy) ] \
               + a5*(wvt2[ Wpzxyloc(iz,ix-5,iy) ] + wvt2[ Wpzxyloc(iz,ix+5,iy) ]) + a4*(wvt2[ Wpzxyloc(iz,ix-4,iy) ] + wvt2[ Wpzxyloc(iz,ix+4,iy) ]) + a3*(wvt2[ Wpzxyloc(iz,ix-3,iy) ] + wvt2[ Wpzxyloc(iz,ix+3,iy) ]) + a2*(wvt2[ Wpzxyloc(iz,ix-2,iy) ] + wvt2[ Wpzxyloc(iz,ix+2,iy) ] )+ a1*(wvt2[ Wpzxyloc(iz,ix-1,iy) ] + wvt2[ Wpzxyloc(iz,ix+1,iy) ]) \
               + a5*(wvt2[ Wpzxyloc(iz,ix,iy-5) ] + wvt2[ Wpzxyloc(iz,ix,iy+5) ])+a4*(wvt2[ Wpzxyloc(iz,ix,iy-4) ] + wvt2[ Wpzxyloc(iz,ix,iy+4) ]) + a3*(wvt2[ Wpzxyloc(iz,ix,iy-3) ] + wvt2[ Wpzxyloc(iz,ix,iy+3) ]) + a2*(wvt2[ Wpzxyloc(iz,ix,iy-2) ] + wvt2[ Wpzxyloc(iz,ix,iy+2) ]) + a1*(wvt2[ Wpzxyloc(iz,ix,iy-1) ] + wvt2[ Wpzxyloc(iz,ix,iy+1) ]);
          /*
          temp1= a5*wvt2[ Wpzxyloc(iz-5,ix,iy) ] +   a4*wvt2[ Wpzxyloc(iz-4,ix,iy) ] + a3*wvt2[ Wpzxyloc(iz-3,ix,iy) ] + a2*wvt2[ Wpzxyloc(iz-2,ix,iy) ] + a1*wvt2[ Wpzxyloc(iz-1,ix,iy) ] - 6.0*a0*curval + a1*wvt2[ Wpzxyloc(iz+1,ix,iy) ] + a2*wvt2[ Wpzxyloc(iz+2,ix,iy) ] + a3*wvt2[ Wpzxyloc(iz+3,ix,iy) ] + a4*wvt2[ Wpzxyloc(iz+4,ix,iy) ] + a5*wvt2[ Wpzxyloc(iz+5,ix,iy) ] \
               + a5*wvt2[ Wpzxyloc(iz,ix-5,iy) ] + a4*wvt2[ Wpzxyloc(iz,ix-4,iy) ] + a3*wvt2[ Wpzxyloc(iz,ix-3,iy) ] + a2*wvt2[ Wpzxyloc(iz,ix-2,iy) ] + a1*wvt2[ Wpzxyloc(iz,ix-1,iy) ] + a1*wvt2[ Wpzxyloc(iz,ix+1,iy) ] + a2*wvt2[ Wpzxyloc(iz,ix+2,iy) ] + a3*wvt2[ Wpzxyloc(iz,ix+3,iy) ] + a4*wvt2[ Wpzxyloc(iz,ix+4,iy) ] + a5*wvt2[ Wpzxyloc(iz,ix+5,iy) ] \ 
               + a5*wvt2[ Wpzxyloc(iz,ix,iy-5) ] + a4*wvt2[ Wpzxyloc(iz,ix,iy-4) ] + a3*wvt2[ Wpzxyloc(iz,ix,iy-3) ] + a2*wvt2[ Wpzxyloc(iz,ix,iy-2) ] + a1*wvt2[ Wpzxyloc(iz,ix,iy-1) ] + a1*wvt2[ Wpzxyloc(iz,ix,iy+1) ] + a2*wvt2[ Wpzxyloc(iz,ix,iy+2) ] + a3*wvt2[ Wpzxyloc(iz,ix,iy+3) ] + a4*wvt2[ Wpzxyloc(iz,ix,iy+4) ] + a5*wvt2[ Wpzxyloc(iz,ix,iy+5) ];
          */
          /*
          temp1= a5*wvt2[ curidx-5 ] +   a4*wvt2[ curidx-4 ] + a3*wvt2[ curidx-3 ] + a2*wvt2[ curidx-2 ] + a1*wvt2[ curidx-1 ] - 6.0*a0*curval + a1*wvt2[ curidx+1 ] + a2*wvt2[ curidx+2 ] + a3*wvt2[ curidx+3 ] + a4*wvt2[ curidx+4 ] + a5*wvt2[ curidx+5 ] \
                + a5*wvt2[ curidx-5*nz ] + a4*wvt2[ curidx-4*nz ] + a3*wvt2[ curidx-3*nz ] + a2*wvt2[ curidx-2*nz ] + a1*wvt2[ curidx-nz ] + a1*wvt2[ curidx+nz ] + a2*wvt2[ curidx+2*nz ] + a3*wvt2[ curidx+3*nz ] + a4*wvt2[ curidx+4*nz ] + a5*wvt2[ curidx+5*nz ] \ 
                + a5*wvt2[ curidx-5*nz*nx ] + a4*wvt2[ curidx-4*nz*nx ] + a3*wvt2[ curidx-3*nz*nx ] + a2*wvt2[ curidx-2*nz*nx ] + a1*wvt2[ curidx-nz*nx ] + a1*wvt2[ curidx+nz*nx ] + a2*wvt2[ curidx+2*nz*nx ] + a3*wvt2[ curidx+3*nz*nx ] + a4*wvt2[ curidx+4*nz*nx ] + a5*wvt2[ curidx+5*nz*nx ];
          */
          wvt3[curidx]  = temp1*veldtinvdx2[curidx];
          
        }   
     } 
  } 

  a2=-1./12.;
  a1=4./3.;
  a0=a1+a2;
  for (iy=0+fat;iy<ny-fat;iy++)
  {
     #pragma omp parallel for private(curidx,curval,temp1,outval,ix,iz) schedule(dynamic,8)
     for (ix=0+fat;ix<nx-fat;ix++)
     {
        //#pragma omp parallel for private(izbegpad,izendpad,whtzbegpad,whtzendpad,curidx,curval,temp1,outval) schedule(dynamic,8)
        for (iz=iz1;iz<iz2;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt3[ curidx ];
          temp1= a2*wvt3[ Wpzxyloc(iz-2,ix,iy) ] + a1*wvt3[ Wpzxyloc(iz-1,ix,iy) ] - 6.0*a0*curval + a1*wvt3[ Wpzxyloc(iz+1,ix,iy) ] + a2*wvt3[ Wpzxyloc(iz+
2,ix,iy) ] \
               + a2*wvt3[ Wpzxyloc(iz,ix-2,iy) ] + a1*wvt3[ Wpzxyloc(iz,ix-1,iy) ] + a1*wvt3[ Wpzxyloc(iz,ix+1,iy) ] + a2*wvt3[ Wpzxyloc(iz,ix+2,iy) ] \
               + a2*wvt3[ Wpzxyloc(iz,ix,iy-2) ] + a1*wvt3[ Wpzxyloc(iz,ix,iy-1) ] + a1*wvt3[ Wpzxyloc(iz,ix,iy+1) ] + a2*wvt3[ Wpzxyloc(iz,ix,iy+2) ] ;
          outval  = 2.0*wvt2[curidx]- wvt1[curidx] + curval - a2*veldtinvdx2[curidx]*temp1;
          wvt1[curidx] = outval;
        }
     }
  }
  
  return 0; 
}
