///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
// 2nd order in time
// 4nd order in space
// no boundary condition
int XC3dWaveprop_1step4t10spacewithbnd(float *veldtinvdx2, int izmin, int izmax)
{
  int fat,curidx;
  int ix,iy,iz;
  int iz1,iz2;
  fat=5;

  float temp1,curval;
  float *wvt1,*wvt2,*wvt3;
  wvt1=XC3dWaveprop_wavet1;
  wvt2=XC3dWaveprop_wavet2;
  wvt3=XC3dWaveprop_wavet3;
  
  int nx,ny,nz;
  nx=XC3dWaveprop_nx;
  ny=XC3dWaveprop_ny;
  nz=XC3dWaveprop_nz;
  int nxtape,nytape,nztape;
  nxtape=XC3dWaveprop_nxtape;
  nytape=XC3dWaveprop_nytape;
  nztape=XC3dWaveprop_nztape;

  iz1=max(0+fat,izmin-fat);
  iz2=min(nz-fat,izmax+fat);

  float a5=1./3150.;
  float a4=-5./1008.;
  float a3=5./126.;
  float a2=-5./21.;
  float a1=5./3.;
  float a0=a1+a2+a3+a4+a5;

  
  float ixbegpad,ixendpad;
  float iybegpad,iyendpad;
  float izbegpad,izendpad;
  float outval;

  float whtxbegpad,whtxendpad;
  float whtybegpad,whtyendpad;
  float whtzbegpad,whtzendpad;

     //#pragma omp parallel for private(iybegpad,iyendpad,whtybegpad,whtyendpad,izbegpad,izendpad,whtzbegpad,whtzendpad,ixbegpad,ixendpad,whtxbegpad,whtxendpad,curidx,curval,temp1,outval) schedule(dynamic,8)
  for (iy=0+fat;iy<ny-fat;iy++)
  {

     #pragma omp parallel for private(curidx,curval,temp1,outval) schedule(dynamic,8)
     for (ix=0+fat;ix<nx-fat;ix++)
     {
        //#pragma omp parallel for private(izbegpad,izendpad,whtzbegpad,whtzendpad,curidx,curval,temp1,outval) schedule(dynamic,8)
        for (iz=iz1;iz<iz2;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt2[ curidx ];
          temp1= a5*wvt2[ Wpzxyloc(iz-5,ix,iy) ] +   a4*wvt2[ Wpzxyloc(iz-4,ix,iy) ] + a3*wvt2[ Wpzxyloc(iz-3,ix,iy) ] + a2*wvt2[ Wpzxyloc(iz-2,ix,iy) ] + a1*wvt2[ Wpzxyloc(iz-1,ix,iy) ] - 6.0*a0*curval + a1*wvt2[ Wpzxyloc(iz+1,ix,iy) ] + a2*wvt2[ Wpzxyloc(iz+2,ix,iy) ] + a3*wvt2[ Wpzxyloc(iz+3,ix,iy) ] + a4*wvt2[ Wpzxyloc(iz+4,ix,iy) ] + a5*wvt2[ Wpzxyloc(iz+5,ix,iy) ] \
                + a5*wvt2[ Wpzxyloc(iz,ix-5,iy) ] + a4*wvt2[ Wpzxyloc(iz,ix-4,iy) ] + a3*wvt2[ Wpzxyloc(iz,ix-3,iy) ] + a2*wvt2[ Wpzxyloc(iz,ix-2,iy) ] + a1*wvt2[ Wpzxyloc(iz,ix-1,iy) ] + a1*wvt2[ Wpzxyloc(iz,ix+1,iy) ] + a2*wvt2[ Wpzxyloc(iz,ix+2,iy) ] + a3*wvt2[ Wpzxyloc(iz,ix+3,iy) ] + a4*wvt2[ Wpzxyloc(iz,ix+4,iy) ] + a5*wvt2[ Wpzxyloc(iz,ix+5,iy) ] \ 
                + a5*wvt2[ Wpzxyloc(iz,ix,iy-5) ] + a4*wvt2[ Wpzxyloc(iz,ix,iy-4) ] + a3*wvt2[ Wpzxyloc(iz,ix,iy-3) ] + a2*wvt2[ Wpzxyloc(iz,ix,iy-2) ] + a1*wvt2[ Wpzxyloc(iz,ix,iy-1) ] + a1*wvt2[ Wpzxyloc(iz,ix,iy+1) ] + a2*wvt2[ Wpzxyloc(iz,ix,iy+2) ] + a3*wvt2[ Wpzxyloc(iz,ix,iy+3) ] + a4*wvt2[ Wpzxyloc(iz,ix,iy+4) ] + a5*wvt2[ Wpzxyloc(iz,ix,iy+5) ];
          wvt3[curidx]  = temp1*veldtinvdx2[curidx];
          
        }   
     } 
  } 

  a2=-1./12.;
  a1=4./3.;
  a0=a1+a2;
  double pi=3.141592653589793;
  for (iy=0+fat;iy<ny-fat;iy++)
  {
     iybegpad=1.f-min(1.f,max(iy-nytape,0));
     iyendpad=1.f-min(1.f,max(ny-nytape-iy,0));
     whtybegpad=iybegpad*(1.-iy/nytape); 
     whtyendpad=iyendpad*(1.-(ny-iy)/nytape); 
     /*
     fprintf(stderr,"iy=%d \n", iy);
     fprintf(stderr,"ny=%d, nytape=%d \n", ny, nytape);
     fprintf(stderr,"iybegpad=%f iyendpad=%f \n", iybegpad,iyendpad);
     fprintf(stderr,"whtybegpad=%f whtyendpad=%f \n", whtybegpad,whtyendpad);
     */
     #pragma omp parallel for private(izbegpad,izendpad,whtzbegpad,whtzendpad,ixbegpad,ixendpad,whtxbegpad,whtxendpad,curidx,curval,temp1,outval) schedule(dynamic,8)
     for (ix=0+fat;ix<nx-fat;ix++)
     {
        ixbegpad=1.f-min(1.f,max(ix-nxtape,0));
        ixendpad=1.f-min(1.f,max(nx-nxtape-ix,0));
        whtxbegpad=ixbegpad*(1.-ix/nxtape); 
        whtxendpad=ixendpad*(1.-(nx-ix)/nxtape); 
        //#pragma omp parallel for private(izbegpad,izendpad,whtzbegpad,whtzendpad,curidx,curval,temp1,outval) schedule(dynamic,8)
        for (iz=iz1;iz<iz2;iz++)
        {
          izbegpad=1.f-min(1.f,max(iz-nztape,0));
          izendpad=1.f-min(1.f,max(nz-nztape-iz,0));
          whtzbegpad=izbegpad*(1.-iz/nztape); 
          whtzendpad=izendpad*(1.-((nz-iz)/nztape)); 

          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt3[ curidx ];
          temp1= a2*wvt3[ Wpzxyloc(iz-2,ix,iy) ] + a1*wvt3[ Wpzxyloc(iz-1,ix,iy) ] - 6.0*a0*curval + a1*wvt3[ Wpzxyloc(iz+1,ix,iy) ] + a2*wvt3[ Wpzxyloc(iz+
2,ix,iy) ] \
               + a2*wvt3[ Wpzxyloc(iz,ix-2,iy) ] + a1*wvt3[ Wpzxyloc(iz,ix-1,iy) ] + a1*wvt3[ Wpzxyloc(iz,ix+1,iy) ] + a2*wvt3[ Wpzxyloc(iz,ix+2,iy) ] \
               + a2*wvt3[ Wpzxyloc(iz,ix,iy-2) ] + a1*wvt3[ Wpzxyloc(iz,ix,iy-1) ] + a1*wvt3[ Wpzxyloc(iz,ix,iy+1) ] + a2*wvt3[ Wpzxyloc(iz,ix,iy+2) ] ;
          outval  = 2.0*wvt2[curidx]- wvt1[curidx] + curval - a2*veldtinvdx2[curidx]*temp1;
          /*
          outval += 0.001*((1.-expf(whtzendpad*4.2))+(1.-expf(whtzbegpad*4.2))+(1.-expf(whtyendpad*4.2))+(1.-expf(whtybegpad*4.2))+(1.-expf(whtxendpad*4.2))+(1.-expf(whtxbegpad*4.2)))*(wvt2[curidx]-wvt1[curidx]);
          wvt1[curidx] = outval*expf(0.0005*(whtzendpad+whtzbegpad+whtyendpad+whtybegpad+whtxendpad+whtxbegpad));
          */
          outval -= 0.04*(whtzendpad+whtzbegpad+whtyendpad+whtybegpad+whtxendpad+whtxbegpad)*(wvt2[curidx]-wvt1[curidx]);
          wvt1[curidx] = outval;

        }
     }
  }

  return 0; 
}
