///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
// 2nd order in time
// 4nd order in space
// no boundary condition
int XC3dWaveprop_1step4t10spacewithbnd1opt1(float *veldtinvdx2, int izmin, int izmax)
{
  int fat,fat2,curidx;
  int ix,iy,iz;
  int iz1,iz2;
  fat=5;
  fat2=5;

  float temp1;
  float *wvt1,*wvt2,*wvt3;
  wvt1=XC3dWaveprop_wavet1;
  wvt2=XC3dWaveprop_wavet2;
  wvt3=XC3dWaveprop_wavet3;
  
  int nx,ny,nz;
  nx=XC3dWaveprop_nx;
  ny=XC3dWaveprop_ny;
  nz=XC3dWaveprop_nz;
  int nxtape,nytape,nztape;
  nxtape=XC3dWaveprop_nxtape;
  nytape=XC3dWaveprop_nytape;
  nztape=XC3dWaveprop_nztape;

  iz1=max(0+fat,izmin-fat);
  iz2=min(nz-fat,izmax+fat);

  float a5=1./3150.;
  float a4=-5./1008.;
  float a3=5./126.;
  float a2=-5./21.;
  float a1=5./3.;
  float a0=a1+a2+a3+a4+a5;

  
  float curv,scurv;
  float curval,outval;
  float tpwht=0.25f;
  float zval[11];
  int idiff;
     //#pragma omp parallel for private(iybegpad,iyendpad,whtybegpad,whtyendpad,izbegpad,izendpad,whtzbegpad,whtzendpad,ixbegpad,ixendpad,whtxbegpad,whtxendpad,curidx,curval,temp1,outval) schedule(dynamic,8)

     //#pragma omp parallel for private(curidx,curval,temp1,outval,ix,iz,iy) schedule(dynamic,8)
  for (iy=0+fat;iy<ny-fat;iy++)
  {

     #pragma omp parallel for private(curidx,curval,temp1,outval,ix,iz,zval,idiff) schedule(dynamic,8)
     for (ix=0+fat;ix<nx-fat;ix++)
     {
        zval[0]=wvt2[Wpzxyloc(iz1-5,ix,iy)];
        zval[1]=wvt2[Wpzxyloc(iz1-4,ix,iy)];
        zval[2]=wvt2[Wpzxyloc(iz1-3,ix,iy)];
        zval[3]=wvt2[Wpzxyloc(iz1-2,ix,iy)];
        zval[4]=wvt2[Wpzxyloc(iz1-1,ix,iy)];
        zval[5]=wvt2[Wpzxyloc(iz1-0,ix,iy)];
        zval[6]=wvt2[Wpzxyloc(iz1+1,ix,iy)];
        zval[7]=wvt2[Wpzxyloc(iz1+2,ix,iy)];
        zval[8]=wvt2[Wpzxyloc(iz1+3,ix,iy)];
        zval[9]=wvt2[Wpzxyloc(iz1+4,ix,iy)];
        zval[10]=wvt2[Wpzxyloc(iz1+5,ix,iy)];
        //#pragma omp parallel for private(curidx,curval,temp1,outval) schedule(dynamic,8)
        for (iz=iz1;iz<iz2;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt2[curidx];
          idiff=iz-iz1; 
          //temp1= a5*wvt2[ Wpzxyloc(iz-5,ix,iy) ] +   a4*wvt2[ Wpzxyloc(iz-4,ix,iy) ] + a3*wvt2[ Wpzxyloc(iz-3,ix,iy) ] + a2*wvt2[ Wpzxyloc(iz-2,ix,iy) ] + a1*wvt2[ Wpzxyloc(iz-1,ix,iy) ] - 6.0*a0*curval + a1*wvt2[ Wpzxyloc(iz+1,ix,iy) ] + a2*wvt2[ Wpzxyloc(iz+2,ix,iy) ] + a3*wvt2[ Wpzxyloc(iz+3,ix,iy) ] + a4*wvt2[ Wpzxyloc(iz+4,ix,iy) ] + a5*wvt2[ Wpzxyloc(iz+5,ix,iy) ] 
          temp1= a5*zval[(0+idiff)%11] + a4*zval[(1+idiff)%11] + a3*zval[(2+idiff)%11] + a2*zval[(3+idiff)%11] + a1*zval[(4+idiff)%11] - 6.0*a0*zval[(5+idiff)%11] + a1*zval[(6+idiff)%11] + a2*zval[(7+idiff)%11] + a3*zval[(8+idiff)%11] + a4*zval[(9+idiff)%11] + a5*zval[(10+idiff)%11] \
               + a5*(wvt2[ Wpzxyloc(iz,ix-5,iy) ] + wvt2[ Wpzxyloc(iz,ix+5,iy) ]) + a4*(wvt2[ Wpzxyloc(iz,ix-4,iy) ] + wvt2[ Wpzxyloc(iz,ix+4,iy) ]) + a3*(wvt2[ Wpzxyloc(iz,ix-3,iy) ] + wvt2[ Wpzxyloc(iz,ix+3,iy) ]) + a2*(wvt2[ Wpzxyloc(iz,ix-2,iy) ] + wvt2[ Wpzxyloc(iz,ix+2,iy) ] )+ a1*(wvt2[ Wpzxyloc(iz,ix-1,iy) ] + wvt2[ Wpzxyloc(iz,ix+1,iy) ]) \
               + a5*(wvt2[ Wpzxyloc(iz,ix,iy-5) ] + wvt2[ Wpzxyloc(iz,ix,iy+5) ])+a4*(wvt2[ Wpzxyloc(iz,ix,iy-4) ] + wvt2[ Wpzxyloc(iz,ix,iy+4) ]) + a3*(wvt2[ Wpzxyloc(iz,ix,iy-3) ] + wvt2[ Wpzxyloc(iz,ix,iy+3) ]) + a2*(wvt2[ Wpzxyloc(iz,ix,iy-2) ] + wvt2[ Wpzxyloc(iz,ix,iy+2) ]) + a1*(wvt2[ Wpzxyloc(iz,ix,iy-1) ] + wvt2[ Wpzxyloc(iz,ix,iy+1) ]);
          /*
          temp1= a5*wvt2[ Wpzxyloc(iz-5,ix,iy) ] +   a4*wvt2[ Wpzxyloc(iz-4,ix,iy) ] + a3*wvt2[ Wpzxyloc(iz-3,ix,iy) ] + a2*wvt2[ Wpzxyloc(iz-2,ix,iy) ] + a1*wvt2[ Wpzxyloc(iz-1,ix,iy) ] - 6.0*a0*curval + a1*wvt2[ Wpzxyloc(iz+1,ix,iy) ] + a2*wvt2[ Wpzxyloc(iz+2,ix,iy) ] + a3*wvt2[ Wpzxyloc(iz+3,ix,iy) ] + a4*wvt2[ Wpzxyloc(iz+4,ix,iy) ] + a5*wvt2[ Wpzxyloc(iz+5,ix,iy) ] \
               + a5*wvt2[ Wpzxyloc(iz,ix-5,iy) ] + a4*wvt2[ Wpzxyloc(iz,ix-4,iy) ] + a3*wvt2[ Wpzxyloc(iz,ix-3,iy) ] + a2*wvt2[ Wpzxyloc(iz,ix-2,iy) ] + a1*wvt2[ Wpzxyloc(iz,ix-1,iy) ] + a1*wvt2[ Wpzxyloc(iz,ix+1,iy) ] + a2*wvt2[ Wpzxyloc(iz,ix+2,iy) ] + a3*wvt2[ Wpzxyloc(iz,ix+3,iy) ] + a4*wvt2[ Wpzxyloc(iz,ix+4,iy) ] + a5*wvt2[ Wpzxyloc(iz,ix+5,iy) ] \ 
               + a5*wvt2[ Wpzxyloc(iz,ix,iy-5) ] + a4*wvt2[ Wpzxyloc(iz,ix,iy-4) ] + a3*wvt2[ Wpzxyloc(iz,ix,iy-3) ] + a2*wvt2[ Wpzxyloc(iz,ix,iy-2) ] + a1*wvt2[ Wpzxyloc(iz,ix,iy-1) ] + a1*wvt2[ Wpzxyloc(iz,ix,iy+1) ] + a2*wvt2[ Wpzxyloc(iz,ix,iy+2) ] + a3*wvt2[ Wpzxyloc(iz,ix,iy+3) ] + a4*wvt2[ Wpzxyloc(iz,ix,iy+4) ] + a5*wvt2[ Wpzxyloc(iz,ix,iy+5) ];
          */
          /*
          temp1= a5*wvt2[ curidx-5 ] +   a4*wvt2[ curidx-4 ] + a3*wvt2[ curidx-3 ] + a2*wvt2[ curidx-2 ] + a1*wvt2[ curidx-1 ] - 6.0*a0*curval + a1*wvt2[ curidx+1 ] + a2*wvt2[ curidx+2 ] + a3*wvt2[ curidx+3 ] + a4*wvt2[ curidx+4 ] + a5*wvt2[ curidx+5 ] \
                + a5*wvt2[ curidx-5*nz ] + a4*wvt2[ curidx-4*nz ] + a3*wvt2[ curidx-3*nz ] + a2*wvt2[ curidx-2*nz ] + a1*wvt2[ curidx-nz ] + a1*wvt2[ curidx+nz ] + a2*wvt2[ curidx+2*nz ] + a3*wvt2[ curidx+3*nz ] + a4*wvt2[ curidx+4*nz ] + a5*wvt2[ curidx+5*nz ] \ 
                + a5*wvt2[ curidx-5*nz*nx ] + a4*wvt2[ curidx-4*nz*nx ] + a3*wvt2[ curidx-3*nz*nx ] + a2*wvt2[ curidx-2*nz*nx ] + a1*wvt2[ curidx-nz*nx ] + a1*wvt2[ curidx+nz*nx ] + a2*wvt2[ curidx+2*nz*nx ] + a3*wvt2[ curidx+3*nz*nx ] + a4*wvt2[ curidx+4*nz*nx ] + a5*wvt2[ curidx+5*nz*nx ];
          */
          wvt3[curidx]  = temp1*veldtinvdx2[curidx];
          zval[idiff%11]=wvt2[curidx+6];
        }   
     } 
  } 

  a2=-1./12.;
  a1=4./3.;
  a0=a1+a2;
  for (iy=0+fat;iy<ny-fat;iy++)
  {
     #pragma omp parallel for private(curidx,curval,temp1,outval,ix,iz) schedule(dynamic,8)
     for (ix=0+fat;ix<nx-fat;ix++)
     {
        //#pragma omp parallel for private(izbegpad,izendpad,whtzbegpad,whtzendpad,curidx,curval,temp1,outval) schedule(dynamic,8)
        for (iz=iz1;iz<iz2;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt3[ curidx ];
          temp1= a2*wvt3[ Wpzxyloc(iz-2,ix,iy) ] + a1*wvt3[ Wpzxyloc(iz-1,ix,iy) ] - 6.0*a0*curval + a1*wvt3[ Wpzxyloc(iz+1,ix,iy) ] + a2*wvt3[ Wpzxyloc(iz+
2,ix,iy) ] \
               + a2*wvt3[ Wpzxyloc(iz,ix-2,iy) ] + a1*wvt3[ Wpzxyloc(iz,ix-1,iy) ] + a1*wvt3[ Wpzxyloc(iz,ix+1,iy) ] + a2*wvt3[ Wpzxyloc(iz,ix+2,iy) ] \
               + a2*wvt3[ Wpzxyloc(iz,ix,iy-2) ] + a1*wvt3[ Wpzxyloc(iz,ix,iy-1) ] + a1*wvt3[ Wpzxyloc(iz,ix,iy+1) ] + a2*wvt3[ Wpzxyloc(iz,ix,iy+2) ] ;
          outval  = 2.0*wvt2[curidx]- wvt1[curidx] + curval - a2*veldtinvdx2[curidx]*temp1;
          wvt1[curidx] = outval;
        }
     }
  }
  
  ////////////////////////////////////////////////////
  //boundary condition
  #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iy,iz) schedule(dynamic,8)
  for (iy=nytape;iy<ny-nytape;iy++)
  {
     //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=nxtape;ix<nx-nxtape;ix++)
     {
        //beg z boundary
        
        for (iz=nztape-1;iz>=0+fat+fat2;iz--)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          outval=wvt1[ curidx ];
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv);
          //outval -= (tpwht*(nztape-iz))/nztape*(scurv*(outval-curval)+curv*(wvt2[Wpzxyloc(iz-1,ix,iy)]-curval));
          outval -= (tpwht*(nztape-iz))/nztape*(scurv*(outval-curval)+curv*(wvt2[curidx-1]-curval));
          wvt1[curidx] = outval;
        }
        for (iz=0+fat+fat2;iz>=0+fat;iz--)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv)*1.2;
          //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxyloc(iz+1,ix,iy)]))+wvt2[Wpzxyloc(iz+1,ix,iy)];
          outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[curidx+1]))+wvt2[curidx+1];
          wvt1[curidx] = outval;
        }
        //end z boundary
        for (iz=nz-nztape;iz<nz-fat-fat2;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          outval=wvt1[ curidx ];
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv);
          //outval -= tpwht*(0.+iz+nztape-nz)/nztape*(scurv*(outval-curval)+curv*(wvt2[Wpzxyloc(iz+1,ix,iy)]-curval));
          outval -= tpwht*(0.+iz+nztape-nz)/nztape*(scurv*(outval-curval)+curv*(wvt2[curidx+1]-curval));
          wvt1[curidx] = outval;
        }
        for (iz=nz-fat-fat2;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv)*1.2;
          //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxyloc(iz-1,ix,iy)]))+wvt2[Wpzxyloc(iz-1,ix,iy)];
          outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[curidx-1]))+wvt2[curidx-1];
          wvt1[curidx] = outval;
        }
     }

     //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     //beg x boundary
     for (ix=nxtape-1;ix>0+fat+fat2;ix--)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          outval=wvt1[ curidx ];
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv);
          //outval -= (tpwht*(nxtape-ix))/nxtape*(scurv*(outval-curval)+curv*(wvt2[Wpzxyloc(iz,ix-1,iy)]-curval));
          outval -= (tpwht*(nxtape-ix))/nxtape*(scurv*(outval-curval)+curv*(wvt2[curidx-nz]-curval));
          wvt1[curidx] = outval;
        }
     }
     //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=0+fat+fat2;ix>=0+fat;ix--)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv)*1.2;
          //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxyloc(iz,ix+1,iy)]))+wvt2[Wpzxyloc(iz,ix+1,iy)];
          outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[curidx+nz]))+wvt2[curidx+nz];
          wvt1[curidx] = outval;
        }
     }

     //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     //end x boundary
     for (ix=nx-nxtape;ix<nx-fat-fat2;ix++)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          outval=wvt1[ curidx ];
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv);
          //outval -= tpwht*(0.+ix+nxtape-nx)/nxtape*(scurv*(outval-curval)+curv*(wvt2[Wpzxyloc(iz,ix+1,iy)]-curval));
          outval -= tpwht*(0.+ix+nxtape-nx)/nxtape*(scurv*(outval-curval)+curv*(wvt2[curidx+nz]-curval));
          wvt1[curidx] = outval;
        }
     }
     //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=nx-fat-fat2;ix<nx-fat;ix++)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv)*1.2;
          //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxyloc(iz,ix-1,iy)]))+wvt2[Wpzxyloc(iz,ix-1,iy)];
          outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[curidx-nz]))+wvt2[curidx-nz];
          wvt1[curidx] = outval;
        }
     }
  }

  ////////////////////////////////////////////////////
  //beg y boundary
  for (iy=nytape-1;iy>0+fat+fat2;iy--)
  {
     #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=0+fat;ix<nx-fat;ix++)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          outval=wvt1[ curidx ];
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv);
          //outval -= (tpwht*(nytape-iy))/nytape*(scurv*(outval-curval)+curv*(wvt2[Wpzxyloc(iz,ix,iy-1)]-curval));
          outval -= (tpwht*(nytape-iy))/nytape*(scurv*(outval-curval)+curv*(wvt2[curidx-nz*nx]-curval));
          wvt1[curidx] = outval;
        }
     }
  }
  
  for (iy=0+fat+fat2;iy>=0+fat;iy--)
  {
     #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=0+fat;ix<nx-fat;ix++)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv)*1.2;
          //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxyloc(iz,ix,iy+1)]))+wvt2[Wpzxyloc(iz,ix,iy+1)];
          outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[curidx+nz*nx]))+wvt2[curidx+nz*nx];
          wvt1[curidx] = outval;
        }
     }
  }
  //end y boundary
  for (iy=ny-nytape;iy<ny-fat-fat2;iy++)
  {
     #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=0+fat;ix<nx-fat;ix++)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          outval=wvt1[ curidx ];
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv);
          //outval -= tpwht*(0.+iy+nytape-ny)/nytape*(scurv*(outval-curval)+curv*(wvt2[Wpzxyloc(iz,ix,iy+1)]-curval));
          outval -= tpwht*(0.+iy+nytape-ny)/nytape*(scurv*(outval-curval)+curv*(wvt2[curidx+nz*nx]-curval));
          wvt1[curidx] = outval;
        }
     }
  }
  
  for (iy=ny-fat-fat2;iy<ny-fat;iy++)
  {
     #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=0+fat;ix<nx-fat;ix++)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv)*1.2;
          //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxyloc(iz,ix,iy-1)]))+wvt2[Wpzxyloc(iz,ix,iy-1)];
          outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[curidx-nz*nx]))+wvt2[curidx-nz*nx];
          wvt1[curidx] = outval;
        }
     }
  }
  
  return 0; 
}
