#include "XC3dWaveprop.h"
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
// 2nd order in time
// 4nd order in space
// no boundary condition
int XC3dWaveprop_1step4t10spacewithbnd1opt2(float *veldtinvdx2, int izmin, int izmax, int ixmin, int ixmax, int iymin, int iymax, \
                                            int XC3dWaveprop_nxtape, int XC3dWaveprop_nytape, int XC3dWaveprop_nztape, \
                                            int XC3dWaveprop_nx, int XC3dWaveprop_ny, int XC3dWaveprop_nz, \
   	                                    float *XC3dWaveprop_wavet1, float *XC3dWaveprop_wavet2, float *XC3dWaveprop_wavet3, \
                                            float *XC3dWaveprop_tmpwv)
{
  int fat,fat2,curidx;
  int ix,iy,iz,i,iz0;
  int iz1,iz2;
  int ix1,ix2;
  int iy1,iy2;
  int ctrx,ctry,ctrz;
  fat=5;
  fat2=5;

  float temp1;
  float* wvt1;
  float* wvt2;
  float* wvt3;
  float* tmpwv;
  wvt1=XC3dWaveprop_wavet1;
  wvt2=XC3dWaveprop_wavet2;
  wvt3=XC3dWaveprop_wavet3;
  tmpwv=XC3dWaveprop_tmpwv;
  
  int nx,ny,nz;
  nx=XC3dWaveprop_nx;
  ny=XC3dWaveprop_ny;
  nz=XC3dWaveprop_nz;
  int inciz=1;
  int incix=nz;
  int inciy=nz*nx;
  int nxtape,nytape,nztape;
  nxtape=XC3dWaveprop_nxtape;
  nytape=XC3dWaveprop_nytape;
  nztape=XC3dWaveprop_nztape;

  iz1=max(0+fat,izmin);
  iz2=min(nz-fat,izmax);
  ix1=max(0+fat,ixmin);
  ix2=min(nx-fat,ixmax);
  iy1=max(0+fat,iymin);
  iy2=min(ny-fat,iymax);

  float a[11];

  a[0]=1./3150.;
  a[1]=-5./1008.;
  a[2]=5./126.;
  a[3]=-5./21.;
  a[4]=5./3.;
  a[5]=(a[0]+a[1]+a[2]+a[3]+a[4])*(-2.);
  a[6]=5./3.;
  a[7]=-5./21.;
  a[8]=5./126.;
  a[9]=-5./1008.;
  a[10]=1./3150.;

     
  float a1=5./3.;
  float a2=-5./21.;
  float a3=5./126.;
  float a4=-5./1008.;
  float a5=1./3150.;
  float a0=a1+a2+a3+a4+a5;
  float curv,scurv;
  float curval,outval;
  float tpwht=0.25f;
     //#pragma omp parallel for private(iybegpad,iyendpad,whtybegpad,whtyendpad,izbegpad,izendpad,whtzbegpad,whtzendpad,ixbegpad,ixendpad,whtxbegpad,whtxendpad,curidx,curval,temp1,outval) schedule(dynamic,8)

     //#pragma omp parallel for private(curidx,curval,temp1,outval,ix,iz,iy) schedule(dynamic,8)
 
  for (iy=iy1;iy<iy2;iy++)
  {
     #pragma omp parallel for private(ix,iz,temp1) schedule(dynamic,8)
     for (ix=ix1;ix<ix2;ix++)
     {  
        for (iz=iz1;iz<iz2;iz++)
        {
           //curidx=Wpzxyloc(iz,ix,iy);
           temp1 = a5*(wvt2[ Wpzxyloc(iz-5,ix,iy) ] + wvt2[ Wpzxyloc(iz+5,ix,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix-5,iy) ] + wvt2[ Wpzxyloc(iz,ix+5,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix,iy-5) ] + wvt2[ Wpzxyloc(iz,ix,iy+5) ] ) ;
           temp1+= a4*(wvt2[ Wpzxyloc(iz-4,ix,iy) ] + wvt2[ Wpzxyloc(iz+4,ix,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix-4,iy) ] + wvt2[ Wpzxyloc(iz,ix+4,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix,iy-4) ] + wvt2[ Wpzxyloc(iz,ix,iy+4) ] ) ;
           temp1+= a3*(wvt2[ Wpzxyloc(iz-3,ix,iy) ] + wvt2[ Wpzxyloc(iz+3,ix,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix-3,iy) ] + wvt2[ Wpzxyloc(iz,ix+3,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix,iy-3) ] + wvt2[ Wpzxyloc(iz,ix,iy+3) ] ) ;
           temp1+= a2*(wvt2[ Wpzxyloc(iz-2,ix,iy) ] + wvt2[ Wpzxyloc(iz+2,ix,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix-2,iy) ] + wvt2[ Wpzxyloc(iz,ix+2,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix,iy-2) ] + wvt2[ Wpzxyloc(iz,ix,iy+2) ] ) ;
           temp1+= a1*(wvt2[ Wpzxyloc(iz-1,ix,iy) ] + wvt2[ Wpzxyloc(iz+1,ix,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix-1,iy) ] + wvt2[ Wpzxyloc(iz,ix+1,iy) ] + \
                       wvt2[ Wpzxyloc(iz,ix,iy-1) ] + wvt2[ Wpzxyloc(iz,ix,iy+1) ] ) ;
           /* 
           temp1 = a5*(wvt2[ Wpzxyloc(iz-5,ix,iy) ] + wvt2[ Wpzxyloc(iz+5,ix,iy) ] ) ;
           temp1+= a5*(wvt2[ Wpzxyloc(iz,ix-5,iy) ] + wvt2[ Wpzxyloc(iz,ix+5,iy) ] ) ;
           temp1+= a5*(wvt2[ Wpzxyloc(iz,ix,iy-5) ] + wvt2[ Wpzxyloc(iz,ix,iy+5) ] ) ;
           temp1+= a4*(wvt2[ Wpzxyloc(iz-4,ix,iy) ] + wvt2[ Wpzxyloc(iz+4,ix,iy) ] ) ;
           temp1+= a4*(wvt2[ Wpzxyloc(iz,ix-4,iy) ] + wvt2[ Wpzxyloc(iz,ix+4,iy) ] ) ;
           temp1+= a4*(wvt2[ Wpzxyloc(iz,ix,iy-4) ] + wvt2[ Wpzxyloc(iz,ix,iy+4) ] ) ;
           temp1+= a3*(wvt2[ Wpzxyloc(iz-3,ix,iy) ] + wvt2[ Wpzxyloc(iz+3,ix,iy) ] ) ;
           temp1+= a3*(wvt2[ Wpzxyloc(iz,ix-3,iy) ] + wvt2[ Wpzxyloc(iz,ix+3,iy) ] ) ; 
           temp1+= a3*(wvt2[ Wpzxyloc(iz,ix,iy-3) ] + wvt2[ Wpzxyloc(iz,ix,iy+3) ] ) ;
           temp1+= a2*(wvt2[ Wpzxyloc(iz-2,ix,iy) ] + wvt2[ Wpzxyloc(iz+2,ix,iy) ] ) ;
           temp1+= a2*(wvt2[ Wpzxyloc(iz,ix-2,iy) ] + wvt2[ Wpzxyloc(iz,ix+2,iy) ] ) ;
           temp1+= a2*(wvt2[ Wpzxyloc(iz,ix,iy-2) ] + wvt2[ Wpzxyloc(iz,ix,iy+2) ] ) ;
           temp1+= a1*(wvt2[ Wpzxyloc(iz-1,ix,iy) ] + wvt2[ Wpzxyloc(iz+1,ix,iy) ] ) ;
           temp1+= a1*(wvt2[ Wpzxyloc(iz,ix-1,iy) ] + wvt2[ Wpzxyloc(iz,ix+1,iy) ] ) ;
           temp1+= a1*(wvt2[ Wpzxyloc(iz,ix,iy-1) ] + wvt2[ Wpzxyloc(iz,ix,iy+1) ] ) ;*/
           temp1+= -6.0*a0*wvt2[Wpzxyloc(iz,ix,iy)];
           wvt3[Wpzxyloc(iz,ix,iy)]=temp1*veldtinvdx2[Wpzxyloc(iz,ix,iy)];
        }
     }
  }   
  
  a2=-1./12.;
  a1=4./3.;
  a0=(a1+a2);

  a0*=-6.0*a2;
  a1*=a2;
  a2*=a2;
  
  for (iy=iy1;iy<iy2;iy++)
  {
     #pragma omp parallel for private(temp1,ix,iz) schedule(dynamic,8)
     for (ix=ix1;ix<ix2;ix++)
     {
        for (iz=iz1;iz<iz2;iz++)
        {
          //curidx=Wpzxyloc(iz,ix,iy);
          temp1 = a2*(wvt3[ Wpzxyloc(iz-2,ix,iy) ] + wvt3[ Wpzxyloc(iz+2,ix,iy) ] );
          temp1+= a2*(wvt3[ Wpzxyloc(iz,ix-2,iy) ] + wvt3[ Wpzxyloc(iz,ix+2,iy) ] );
          temp1+= a2*(wvt3[ Wpzxyloc(iz,ix,iy-2) ] + wvt3[ Wpzxyloc(iz,ix,iy+2) ] );
          temp1+= a1*(wvt3[ Wpzxyloc(iz-1,ix,iy) ] + wvt3[ Wpzxyloc(iz+1,ix,iy) ] );
          temp1+= a1*(wvt3[ Wpzxyloc(iz,ix-1,iy) ] + wvt3[ Wpzxyloc(iz,ix+1,iy) ] );
          temp1+= a1*(wvt3[ Wpzxyloc(iz,ix,iy-1) ] + wvt3[ Wpzxyloc(iz,ix,iy+1) ] );
          temp1+= a0*wvt3[Wpzxyloc(iz,ix,iy)];
          temp1*= veldtinvdx2[Wpzxyloc(iz,ix,iy)];
          temp1= wvt3[Wpzxyloc(iz,ix,iy)]-temp1;
          wvt1[Wpzxyloc(iz,ix,iy)] = 2.0*wvt2[Wpzxyloc(iz,ix,iy)]- wvt1[Wpzxyloc(iz,ix,iy)] + temp1;
        }
     }
  }
  
  ////////////////////////////////////////////////////
  //boundary condition
  #pragma omp parallel for private(scurv,outval,ix,iy,iz) schedule(dynamic,8)
  for (iy=nytape;iy<ny-nytape;iy++)
  {
     //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=nxtape;ix<nx-nxtape;ix++)
     {
        //beg z boundary
        
        for (iz=nztape-1;iz>=0+fat+fat2;iz--)
        {
          outval=wvt1[ Wpzxyloc(iz,ix,iy) ];
          scurv=sqrtf(veldtinvdx2[Wpzxyloc(iz,ix,iy)]);
          //outval -= (tpwht*(nztape-iz))/nztape*(scurv*(outval-curval)+curv*(wvt2[Wpzxyloc(iz-1,ix,iy)]-curval));
          outval -= (tpwht*(nztape-iz))/nztape*(scurv*(outval-wvt2[Wpzxyloc(iz,ix,iy)])+scurv*scurv*(wvt2[Wpzxyloc(iz-1,ix,iy)]-wvt2[Wpzxyloc(iz,ix,iy)]));
          wvt1[Wpzxyloc(iz,ix,iy)] = outval;
        }
        for (iz=0+fat+fat2;iz>=0+fat;iz--)
        {
          scurv=sqrtf(veldtinvdx2[Wpzxyloc(iz,ix,iy)])*1.2;
          //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxyloc(iz+1,ix,iy)]))+wvt2[Wpzxyloc(iz+1,ix,iy)];
          wvt1[Wpzxyloc(iz,ix,iy)] = 1./(1.+scurv)*((1.-scurv)*(wvt2[Wpzxyloc(iz,ix,iy)]-wvt1[Wpzxyloc(iz+1,ix,iy)]))+wvt2[Wpzxyloc(iz+1,ix,iy)];
        }
        //end z boundary
        for (iz=nz-nztape;iz<nz-fat-fat2;iz++)
        {
          outval=wvt1[ Wpzxyloc(iz,ix,iy) ];
          scurv=sqrtf(veldtinvdx2[Wpzxyloc(iz,ix,iy)]);
          //outval -= tpwht*(0.+iz+nztape-nz)/nztape*(scurv*(outval-curval)+curv*(wvt2[Wpzxyloc(iz+1,ix,iy)]-curval));
          outval -= tpwht*(0.+iz+nztape-nz)/nztape*(scurv*(outval-wvt2[Wpzxyloc(iz,ix,iy)])+scurv*scurv*(wvt2[Wpzxyloc(iz+1,ix,iy)]-wvt2[Wpzxyloc(iz,ix,iy)]));
          wvt1[Wpzxyloc(iz,ix,iy)] = outval;
        }
        for (iz=nz-fat-fat2;iz<nz-fat;iz++)
        {
          scurv=sqrtf(veldtinvdx2[Wpzxyloc(iz,ix,iy)])*1.2;
          //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxyloc(iz-1,ix,iy)]))+wvt2[Wpzxyloc(iz-1,ix,iy)];
          wvt1[Wpzxyloc(iz,ix,iy)] = 1./(1.+scurv)*((1.-scurv)*(wvt2[Wpzxyloc(iz,ix,iy)]-wvt1[Wpzxyloc(iz-1,ix,iy)]))+wvt2[Wpzxyloc(iz-1,ix,iy)];
        }
     }

     //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     //beg x boundary
     for (ix=nxtape-1;ix>0+fat+fat2;ix--)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          outval=wvt1[ Wpzxyloc(iz,ix,iy) ];
          scurv=sqrtf(veldtinvdx2[Wpzxyloc(iz,ix,iy)]);
          //outval -= (tpwht*(nxtape-ix))/nxtape*(scurv*(outval-curval)+curv*(wvt2[Wpzxyloc(iz,ix-1,iy)]-curval));
          outval -= (tpwht*(nxtape-ix))/nxtape*(scurv*(outval-wvt2[Wpzxyloc(iz,ix,iy)])+scurv*scurv*(wvt2[Wpzxyloc(iz,ix-1,iy)]-wvt2[Wpzxyloc(iz,ix,iy)]));
          wvt1[Wpzxyloc(iz,ix,iy)] = outval;
        }
     }
     //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=0+fat+fat2;ix>=0+fat;ix--)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          scurv=sqrtf(veldtinvdx2[Wpzxyloc(iz,ix,iy)])*1.2;
          //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxyloc(iz,ix+1,iy)]))+wvt2[Wpzxyloc(iz,ix+1,iy)];
          wvt1[Wpzxyloc(iz,ix,iy)] = 1./(1.+scurv)*((1.-scurv)*(wvt2[Wpzxyloc(iz,ix,iy)]-wvt1[Wpzxyloc(iz,ix+1,iy)]))+wvt2[Wpzxyloc(iz,ix+1,iy)];
         // wvt1[Wpzxyloc(iz,ix,iy)] = outval;
        }
     }

     //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     //end x boundary
     for (ix=nx-nxtape;ix<nx-fat-fat2;ix++)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          outval=wvt1[ Wpzxyloc(iz,ix,iy) ];
          scurv=sqrtf(veldtinvdx2[Wpzxyloc(iz,ix,iy)]);
          //outval -= tpwht*(0.+ix+nxtape-nx)/nxtape*(scurv*(outval-curval)+curv*(wvt2[Wpzxyloc(iz,ix+1,iy)]-curval));
          outval -= tpwht*(0.+ix+nxtape-nx)/nxtape*(scurv*(outval-wvt2[Wpzxyloc(iz,ix,iy)])+scurv*scurv*(wvt2[Wpzxyloc(iz,ix+1,iy)]-wvt2[Wpzxyloc(iz,ix,iy)]));
          wvt1[Wpzxyloc(iz,ix,iy)] = outval;
        }
     }
     //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=nx-fat-fat2;ix<nx-fat;ix++)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          scurv=sqrtf(veldtinvdx2[Wpzxyloc(iz,ix,iy)])*1.2;
          //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxyloc(iz,ix-1,iy)]))+wvt2[Wpzxyloc(iz,ix-1,iy)];
          outval = 1./(1.+scurv)*((1.-scurv)*(wvt2[Wpzxyloc(iz,ix,iy)]-wvt1[Wpzxyloc(iz,ix-1,iy)]))+wvt2[Wpzxyloc(iz,ix-1,iy)];
          wvt1[Wpzxyloc(iz,ix,iy)] = outval;
        }
     }
  }

  ////////////////////////////////////////////////////
  //beg y boundary
  for (iy=nytape-1;iy>0+fat+fat2;iy--)
  {
     #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=0+fat;ix<nx-fat;ix++)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          outval=wvt1[ curidx ];
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv);
          //outval -= (tpwht*(nytape-iy))/nytape*(scurv*(outval-curval)+curv*(wvt2[Wpzxyloc(iz,ix,iy-1)]-curval));
          outval -= (tpwht*(nytape-iy))/nytape*(scurv*(outval-curval)+curv*(wvt2[curidx-nz*nx]-curval));
          wvt1[curidx] = outval;
        }
     }
  }
  
  for (iy=0+fat+fat2;iy>=0+fat;iy--)
  {
     #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=0+fat;ix<nx-fat;ix++)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv)*1.2;
          //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxyloc(iz,ix,iy+1)]))+wvt2[Wpzxyloc(iz,ix,iy+1)];
          outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[curidx+nz*nx]))+wvt2[curidx+nz*nx];
          wvt1[curidx] = outval;
        }
     }
  }
  //end y boundary
  for (iy=ny-nytape;iy<ny-fat-fat2;iy++)
  {
     #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=0+fat;ix<nx-fat;ix++)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          outval=wvt1[ curidx ];
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv);
          //outval -= tpwht*(0.+iy+nytape-ny)/nytape*(scurv*(outval-curval)+curv*(wvt2[Wpzxyloc(iz,ix,iy+1)]-curval));
          outval -= tpwht*(0.+iy+nytape-ny)/nytape*(scurv*(outval-curval)+curv*(wvt2[curidx+nz*nx]-curval));
          wvt1[curidx] = outval;
        }
     }
  }
  
  for (iy=ny-fat-fat2;iy<ny-fat;iy++)
  {
     #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
     for (ix=0+fat;ix<nx-fat;ix++)
     {
        for (iz=0+fat;iz<nz-fat;iz++)
        {
          curidx=Wpzxyloc(iz,ix,iy);
          curval=wvt2[ curidx ];
          curv=veldtinvdx2[curidx];
          scurv=sqrtf(curv)*1.2;
          //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxyloc(iz,ix,iy-1)]))+wvt2[Wpzxyloc(iz,ix,iy-1)];
          outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[curidx-nz*nx]))+wvt2[curidx-nz*nx];
          wvt1[curidx] = outval;
        }
     }
  }
  
  return 0; 
}
