#include "stdlib.h"
#include "math.h"
#include "string.h"
#include "seplib.h"
#include "sep3d.h"
#include "sep3dc.h"
#include "XC3dWaveprop.h"
#include "XC3dAcouMod.h"


//############
// need to solve sdep/rdep issue
//###########
int main(int argc, char** argv)
{
    fprintf(stderr,"haaha\n");
    int ndim,i,n;
    float o,d;
    char temp_char[256];
    int   nt, nx, ny, nz, ns;
    float ot, ox, oy, oz;
    float dt, dx, dy, dz;
    int   it, ix, iy, iz, is;
    int   nxtape,nytape,nztape;
    int   needwvmv,jtmv, rndbnd, freesurf;
    int   stat,tsign;
    float *vel, *src, *data, *sdep, *rdep, *wvmv;
    sep3d outfile; 
    time_t time1,time2;

    initpar(argc,argv);
    // read t,x,y from source file
   
    if(0!=sep_get_number_data_axes("in",&ndim))
       seperr("unable to get dimension from src!\n");
    
    for(i=1;i<=ndim;i++)
    {
       if(0!=sep_get_data_axis_par("in",&i,&n,&o,&d,temp_char))
       seperr("unable to get parameters from src!\n");
       if(i==1)
       {
          nt=n;
          dt=d;
          ot=o;
       }
       else if(i==2)
       {
          nx=n;
          dx=d;
          ox=o;
       }
       else if(i==3)
       {
          ny=n;
          dy=d;
          oy=o;
       }
       if (ndim==3) 
          ns=1; 
       else if(i==4)
          ns=n;
    }

    // read z info from vel
    if(0!=sep_get_number_data_axes("vel",&ndim))
       seperr("unable to get dimension from vel file!\n");
    for(i=1;i<=ndim;i++)
    {
       if(0!=sep_get_data_axis_par("vel",&i,&n,&o,&d,temp_char))
       seperr("unable to get parameters from vel file!\n");
       if(i==1)
       {
          nz=n;
          dz=d;
          oz=o;
       }
       else if(i==2)
       {
          if (nx!=n)
          Errmsg3("nx in vel %d different from nx %d in src, program terminated!\n",n,nx)
          if (dx!=d)
          Errmsg3("dx in vel %f different from dx %f in src, program terminated!\n",d,dx)
          if (ox!=o)
          Errmsg3("ox in vel %f different from ox %f in src, program terminated!\n",o,ox)
       }
       else if(i==3)
       {
          if (ny!=n)
          Errmsg3("ny in vel %d different from ny %d in src, program terminated!\n",n,ny)
          if (dy!=d)
          Errmsg3("dy in vel %f different from dy %f in src, program terminated!\n",d,dy)
          if (oy!=o)
          Errmsg3("oy in vel %f different from oy %f in src, program terminated!\n",o,oy)
       }
    }

    // readin other parameters
    if (0==getch("nxtape","i", &nxtape)) nxtape=50;
    if (0==getch("nytape","i", &nytape)) nytape=50;
    if (0==getch("nztape","i", &nztape)) nztape=50;
    if (0==getch("needwvmv","i", &needwvmv)) needwvmv=0;
    if (0==getch("jtmv","i", &jtmv)) jtmv=10;
    if (0==getch("rndbnd","i", &rndbnd)) rndbnd=0;
    if (0==getch("freesurf","i", &freesurf)) freesurf=0;
    if (0==getch("tsign","i", &tsign)) tsign=1;

    if (nx<=2*nxtape)
       Errmsg3("Error, nx %d less or equal than twice of padded x reigon %d \n",nx,nxtape);
    if (ny<=2*nytape)
       Errmsg3("Error, ny %d less or equal than twice of padded y reigon %d \n",ny,nytape);
    if (nz<=2*nztape)
       Errmsg3("Error, nz %d less or equal than twice of padded z reigon %d \n",nz,nztape);

    // allocate memories

    vel=(float*)malloc(nx*ny*nz*sizeof(float));
    src=(float*)malloc(nx*ny*nt*sizeof(float));
    if (src==NULL)
       seperr("Error!Fail to allocate for src!\n");
    data=(float*)malloc(nx*ny*nt*sizeof(float));
    if (data==NULL)
       seperr("Error!Fail to allocate for data!\n");
    sdep=(float*)malloc(nx*ny*ns*sizeof(float));
    rdep=(float*)malloc(nx*ny*ns*sizeof(float));

    // read in various data files into arrays
    //if ((nx*ny*nt*ns*4)!=sreed("in",src,nx*ny*nt*ns*4))
    //   Errmsg2("Error read in src file of size %d \n",nx*ny*nt*ns*4);

    if ((nx*ny*nz*4)!=sreed("vel",vel,nx*ny*nz*4))
       Errmsg2("Error read in vel file of size %d \n", nx*ny*nz*4);

    for (i=0;i<nx*ny*ns;i++)
       sdep[i]=2*dz;
    for (i=0;i<nx*ny*ns;i++)
       rdep[i]=2*dz;
    
    
    FILE *fp;
    if ((nx*ny*ns*4)!=sreed("sdep",sdep,nx*ny*ns*4))
    {
       fprintf(stderr,"didn't see sdep file\n");
       for (i=0;i<nx*ny*ns;i++)
          sdep[i]=2*dz;
    }
 
    /* 
    if ((nx*ny*ns*4)!=sreed("rdep",rdep,nx*ny*ns*4))
    {
       fprintf(stderr,"didn't see rdep file\n");
       for (i=0;i<nx*ny*ns;i++)
          rdep[i]=2*dz;
    }*/

    if (needwvmv>0) 
    {
       fprintf(stderr,"start allocating wvmv of size %e \n",((float)(nx*ny*nz*(ny/jtmv))));    
       wvmv=(float*)malloc(nx*ny*nz*(nt/jtmv)*sizeof(float));
       fprintf(stderr,"done allocating wvmv\n");    
       if (wvmv==NULL)
          seperr("Error!Not enough space for wvmv allocating!\n");
    }
    // Initialize wave propagation 
    fprintf(stderr,"sdep=%f\n",sdep[0]);
    VerbMsg("start initialize XC3dAcouMod_Init\n")
    stat=XC3dAcouMod_Init( nt,nx,ny,nz,ns,       \
                           ot,ox,oy,oz,          \
                           dt,dx,dy,dz,          \
                           nxtape,nytape,nztape, \
                           sdep, rdep, vel,      \
                           needwvmv,jtmv, freesurf );

    if (stat==1)
       seperr("Error in XC3dAcouMod_Init,program terminated!\n");
    
    ndim=4;
    if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
       seperr("unable to write outfile!\n");
    outfile.o[0]=ot;
    outfile.d[0]=dt;
    outfile.n[0]=nt;
    outfile.o[1]=ox;
    outfile.d[1]=dx;
    outfile.n[1]=nx;
    outfile.o[2]=oy;
    outfile.d[2]=dy;
    outfile.n[2]=ny;
    outfile.o[3]=0;
    outfile.d[3]=1;
    outfile.n[3]=ns;
    sep3d_set_sep3d(&outfile);
    if(0!=sep3dc_write_description("data",&outfile))
       seperr("unable to output parameters for data\n");

    // run wave propagation 
    VerbMsg("start modeling in XC3dAcouMod_op \n")
    time1=time(NULL);
    fprintf(stderr,"rndbnd==%d\n",rndbnd);
    if (rndbnd==0)
    {
       for (is=0;is<ns;is++) 
       {
          //for (iy=0;iy<ny;iy++) 
          //   if( (nt*nx*4)!=sreed("in",&src[iy*nt*nx],4*nt*nx) )
          if( (nt*nx*ny*4)!=sreed("in",src,4*nt*nx*ny) )
                Errmsg2("Error read in src file of size %d \n",nx*ny*nt*4);
          stat=XC3dAcouMod_op(tsign,is,src,data,wvmv);
          //for (iy=0;iy<ny;iy++) 
          //   if( (nt*nx*4)!=srite("data",&data[iy*nt*nx],4*nt*nx) )
             if( (nt*nx*ny*4)!=srite("data",data,4*nt*nx*ny) )
                seperr("trouble writing out data\n");
       }
          //stat=XC3dAcouMod_op(tsign,is,&src[is*nx*ny*nt],&data[is*nx*ny*nt],wvmv);
    }
    else if (rndbnd==1)
    {
       for (is=0;is<ns;is++) 
       {
          for (iy=0;iy<ny;iy++) 
             if( (nt*nx*4)!=sreed("in",&src[iy*nt*nx],4*nt*nx) )
                Errmsg2("Error read in src file of size %d \n",nx*nt*4);
          stat=XC3dAcouMod_op_rndbnd(tsign,is,src,data,wvmv);
          for (iy=0;iy<ny;iy++) 
             if( (nt*nx*4)!=srite("data",&data[iy*nt*nx],4*nt*nx) )
                seperr("trouble writing out data\n");
       }
          //stat=XC3dAcouMod_op_rndbnd(tsign,is,&src[is*nx*ny*nt],&data[is*nx*ny*nt],wvmv);
    }
    else if (rndbnd==2)
    {
       for (is=0;is<ns;is++) 
       {
          for (iy=0;iy<ny;iy++) 
             if( (nt*nx*4)!=sreed("in",&src[iy*nt*nx],4*nt*nx) )
                Errmsg2("Error read in src file of size %d \n",nx*nt*4);
          //#if ((nx*ny*nt*4)!=sreed("in",src,nx*ny*nt*4))
          //   Errmsg2("Error read in src file of size %d \n",nx*ny*nt*4);
          stat=XC3dAcouMod_op_rndbnd1(tsign,is,src,data,wvmv);
          for (iy=0;iy<ny;iy++) 
             if( (nt*nx*4)!=srite("data",&data[iy*nt*nx],4*nt*nx) )
                seperr("trouble writing out data\n");

       }
          //stat=XC3dAcouMod_op_rndbnd1(tsign,is,&src[is*nx*ny*nt],&data[is*nx*ny*nt],wvmv);
    }

    time2=time(NULL);
    fprintf(stderr,"used time for 1 shot is %ld seconds\n", time2-time1);
    if (stat==1)
       seperr("Error in XC3dAcouMod_op,program terminated!\n");

    //if( (nt*nx*ny*ns*4)!=srite("data",data,4*nt*nx*ny*ns) )
    //   seperr("trouble writing out data\n");

    //output wave movie if necessary
    if (needwvmv>0)
    {
       ndim=4;
       VerbMsg("start output wave movie \n")
       if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
          seperr("unable to write outfile!\n");
       outfile.o[0]=oz;
       outfile.d[0]=dz;
       outfile.n[0]=nz;
       outfile.o[1]=ox;
       outfile.d[1]=dx;
       outfile.n[1]=nx;
       outfile.o[2]=oy;
       outfile.d[2]=dy;
       outfile.n[2]=ny;
       outfile.o[3]=ot;
       outfile.d[3]=dt*jtmv;
       outfile.n[3]=nt/jtmv;
       sep3d_set_sep3d(&outfile);
       VerbMsg("start output wave movie header \n" )
       if(0!=sep3dc_write_description("wvmv",&outfile))
          seperr("unable to output parameters for wvmv\n");

       VerbMsg("start output wave movie data body \n" )
       for (i=0;i<(nt/jtmv);i++) 
       {
          if( (nx*ny*nz*4)!=srite("wvmv",&wvmv[i*nx*ny*nz],4*nx*ny*nz) )
             seperr("trouble writing out wvmv\n");
       }
       VerbMsg("done output wave movie data body \n" )
    }
    return 0;
}
