#include "stdlib.h"
#include "math.h"
#include "string.h"
#include <seplib.h>
#include <sep3dc.h>


#define Errmsg3(str,str1,str2)  {fprintf(stderr,str,str1,str2);return 1;}
int main(int argc, char** argv)
{
    int ndim,i,n;
    float o,d;
    char temp_char[256];
    int   nx, ny, nz;
    float ox, oy, oz;
    float dx, dy, dz;
    int   ix, iy, iz;
    int   needwvmv,jtmv;
    int   stat;
    float *vel;
    float minV,maxV;
    sep3d outfile; 
    initpar(argc,argv);
    // read t,x,y from source file
   
    if(0!=sep_get_number_data_axes("in",&ndim))
       seperr("unable to get dimension from src!\n");
    
    for(i=1;i<=ndim;i++)
    {
       if(0!=sep_get_data_axis_par("in",&i,&n,&o,&d,temp_char))
       seperr("unable to get parameters from src!\n");
       if(i==1)
       {
          nz=n;
          dz=d;
          oz=o;
       }
       else if(i==2)
       {
          nx=n;
          dx=d;
          ox=o;
       }
       else if(i==3)
       {
          ny=n;
          dy=d;
          oy=o;
       }
    }

    // readin other parameters
    if (0==getch("minV","f", &minV)) minV=1000;
    if (0==getch("maxV","f", &maxV)) maxV=2000;

    if (minV>=maxV)
       Errmsg3("Error, minV %f greater than maxV %f \n",minV,maxV);

    // allocate memories

    vel=(float*)malloc(nx*ny*nz*sizeof(float));

    srand(time(NULL));
    for (iy=0;iy<ny;iy++)
       for (ix=0;ix<nx;ix++)
          for (iz=0;iz<nz;iz++)
             vel[iz+ix*nz+iy*nz*nx]=minV+(maxV-minV)*(1.0*rand()/RAND_MAX);

    ndim=3;
    if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
       seperr("unable to write outfile!\n");
    outfile.o[0]=oz;
    outfile.d[0]=dz;
    outfile.n[0]=nz;
    outfile.o[1]=ox;
    outfile.d[1]=dx;
    outfile.n[1]=nx;
    outfile.o[2]=oy;
    outfile.d[2]=dy;
    outfile.n[2]=ny;
    sep3d_set_sep3d(&outfile);
    if(0!=sep3dc_write_description("vel",&outfile))
       seperr("unable to output parameters for vel\n");

    if( (nz*nx*ny*4)!=srite("vel",vel,4*nz*nx*ny) )
       seperr("trouble writing out vel\n");

    return 0;
}
