#include "stdlib.h"
#include "math.h"
#include "string.h"
#include <seplib.h>
#include <sep3dc.h>


#define Errmsg3(str,str1,str2)  {fprintf(stderr,str,str1,str2);return 1;}
int main(int argc, char** argv)
{
    int ndim,i,n;
    float o,d;
    char temp_char[256];
    int   nxtape, nytape, nztape;
    float maxsigma, sigma, alpha_mean, alpha_sigma,alpha_maxV;
    int   nx, ny, nz;
    float ox, oy, oz;
    float dx, dy, dz;
    int   ix, iy, iz;
    int   ix1,iy1,iz1, i1;
    int   needwvmv,jtmv;
    int   stat, j_rndbnd;
    float sin, sinamp,pi,dv;
    float *vel;
    float minV,maxV;
    pi=3.1415926;
    sep3d outfile; 
    initpar(argc,argv);
    // read t,x,y from source file
   
    if(0!=sep_get_number_data_axes("in",&ndim))
       seperr("unable to get dimension from src!\n");
    for(i=1;i<=ndim;i++)
    {
       if(0!=sep_get_data_axis_par("in",&i,&n,&o,&d,temp_char))
       seperr("unable to get parameters from src!\n");
       if(i==1)
       {
          nz=n;
          dz=d;
          oz=o;
       }
       else if(i==2)
       {
          nx=n;
          dx=d;
          ox=o;
       }
       else if(i==3)
       {
          ny=n;
          dy=d;
          oy=o;
       }
    }

    // readin other parameters
    if (0==getch("nxtape","i", &nxtape)) nxtape=0;
    if (0==getch("nytape","i", &nytape)) nytape=0;
    if (0==getch("nztape","i", &nztape)) nztape=0;

    if (0==getch("sigma","f", &sigma)) sigma=100;
    if (0==getch("maxsigma","f", &maxsigma)) maxsigma=10000;
    if (0==getch("alpha_mean","f", &alpha_mean)) alpha_mean=0.1;
    if (0==getch("alpha_sigma","f", &alpha_sigma)) alpha_sigma=0.1;
    if (0==getch("alpha_maxV","f", &alpha_maxV)) alpha_maxV=0.0;
    if (0==getch("sin","f", &sin)) sin=0.;
    if (0==getch("sinamp","f", &sinamp)) sinamp=0.;

    if (0==getch("minV","f", &minV)) minV=1000;
    if (0==getch("maxV","f", &maxV)) maxV=2000;
    if (0==getch("j_rndbnd","i", &j_rndbnd)) j_rndbnd=1;

    if (minV>=maxV)
       Errmsg3("Error, minV %f greater than maxV %f \n",minV,maxV);

    // allocate memories

    vel=(float*)malloc(nx*ny*nz*sizeof(float));

    srand(time(NULL));

    if ((nx*ny*nz*4)!=sreed("in",vel,nx*ny*nz*4))
    {
        fprintf(stderr,"Error read in vel file of size %d \n", nx*ny*nz*4);
        return 1;
    }

    // first pad all boundaries by extending values
    for (iy=nytape;iy<ny-nytape;iy++)
    {
       for (ix=0;ix<nxtape;ix++)
          for (iz=nztape;iz<nz-nztape;iz++)
          {
             vel[iz+ix*nz+iy*nz*nx]=vel[iz+nxtape*nz+iy*nz*nx];
             vel[iz+(nx-1-ix)*nz+iy*nz*nx]=vel[iz+(nx-1-nxtape)*nz+iy*nz*nx];
          }

       for (ix=0;ix<nx;ix++)
          for (iz=0;iz<nztape;iz++)
          {
             vel[iz+ix*nz+iy*nz*nx]=vel[nztape+ix*nz+iy*nz*nx];
             vel[(nz-1-iz)+ix*nz+iy*nz*nx]=vel[(nz-1-nztape)+ix*nz+iy*nz*nx];
          }
    }
 
    for (iy=0;iy<nytape;iy++)
       for (ix=0;ix<nx;ix++)
          for (iz=0;iz<nz;iz++)
          {
             vel[iz+ix*nz+iy*nz*nx]=vel[iz+ix*nz+nytape*nz*nx];
             vel[iz+ix*nz+(ny-1-iy)*nz*nx]=vel[iz+ix*nz+(ny-1-nytape)*nz*nx];
          }

    if (sin==0.)
    { 
       
       // then adjust the mean of boundary regions
       for (iy=0;iy<nytape;iy++)
          for (ix=0;ix<nx;ix++)
             for (iz=0;iz<nz;iz++)
             {
                vel[iz+ix*nz+iy*nz*nx]*=exp(-alpha_mean*(nytape-iy));
                vel[iz+ix*nz+(ny-1-iy)*nz*nx]*=exp(-alpha_mean*(nytape-iy));
             }
    
       for (iy=0;iy<ny;iy++)
          for (ix=0;ix<nxtape;ix++)
             for (iz=0;iz<nz;iz++)
             {
                vel[iz+ix*nz+iy*nz*nx]*=exp(-alpha_mean*(nxtape-ix));
                vel[iz+(nx-1-ix)*nz+iy*nz*nx]*=exp(-alpha_mean*(nxtape-ix));
             }

       for (iy=0;iy<ny;iy++)
          for (ix=0;ix<nx;ix++)
             for (iz=0;iz<nztape;iz++)
             {
                vel[iz+ix*nz+iy*nz*nx]*=exp(-alpha_mean*(nztape-iz));
                vel[(nz-1-iz)+ix*nz+iy*nz*nx]*=exp(-alpha_mean*(nztape-iz));
             }
        
       // then adjust the var of boundary regions
       for (iy=0;iy<nytape;iy++)
          for (ix=0;ix<nx;ix++)
             for (iz=0;iz<nz;iz++)
             {  
                /*
                dv=sigma*exp(alpha_sigma*(nytape-iy))*((2.0*rand()/RAND_MAX)-1.0);
                while (((vel[iz+ix*nz+iy*nz*nx]+dv)>maxV)||((vel[iz+ix*nz+iy*nz*nx]+dv)<minV))
                   dv=sigma*exp(alpha_sigma*(nytape-iy))*((2.0*rand()/RAND_MAX)-1.0);
                vel[iz+ix*nz+iy*nz*nx]+=dv;

                dv=sigma*exp(alpha_sigma*(nytape-iy))*((2.0*rand()/RAND_MAX)-1.0);
                while (((vel[iz+ix*nz+(ny-1-iy)*nz*nx]+dv)>maxV)||((vel[iz+ix*nz+(ny-1-iy)*nz*nx]+dv)<minV))
                   dv=sigma*exp(alpha_sigma*(nytape-iy))*((2.0*rand()/RAND_MAX)-1.0);
                vel[iz+ix*nz+(ny-1-iy)*nz*nx]+=dv;
                */
                i=iz+ix*nz+iy*nz*nx;
                vel[iz+ix*nz+iy*nz*nx]+=fminf(maxsigma,(sigma*exp(alpha_sigma*(nytape-iy))))*((2.0*rand()/RAND_MAX)-1.0);
                if (vel[i]>maxV*exp(alpha_maxV*(nytape-iy)))
                   vel[i]=maxV*exp(alpha_maxV*(nytape-iy));
                i=iz+ix*nz+(ny-1-iy)*nz*nx;
                vel[iz+ix*nz+(ny-1-iy)*nz*nx]+=fminf(maxsigma, (sigma*exp(alpha_sigma*(nytape-iy))))*((2.0*rand()/RAND_MAX)-1.0);
                if (vel[i]>maxV*exp(alpha_maxV*(nytape-iy)))
                   vel[i]=maxV*exp(alpha_maxV*(nytape-iy));

             }
       for (iy=0;iy<ny;iy++)
          for (ix=0;ix<nxtape;ix++)
             for (iz=0;iz<nz;iz++)
             {
                /*
                dv=sigma*exp(alpha_sigma*(nxtape-ix))*((2.0*rand()/RAND_MAX)-1.0);
                while (((vel[iz+ix*nz+iy*nz*nx]+dv)>maxV)||((vel[iz+ix*nz+iy*nz*nx]+dv)<minV))
		   dv=sigma*exp(alpha_sigma*(nxtape-ix))*((2.0*rand()/RAND_MAX)-1.0);
	        vel[iz+ix*nz+iy*nz*nx]+=dv;
                
	        dv=sigma*exp(alpha_sigma*(nxtape-ix))*((2.0*rand()/RAND_MAX)-1.0);
	        while (((vel[iz+(nx-1-ix)*nz+iy*nz*nx]+dv)>maxV)||((vel[iz+(nx-1-ix)*nz+iy*nz*nx]+dv)<minV))
		   dv=sigma*exp(alpha_sigma*(nxtape-ix))*((2.0*rand()/RAND_MAX)-1.0);
	        vel[iz+(nx-1-ix)*nz+iy*nz*nx]+=dv;
                */
                i=iz+ix*nz+iy*nz*nx;
                vel[iz+ix*nz+iy*nz*nx]+=fminf(maxsigma, (sigma*exp(alpha_sigma*(nxtape-ix))))*((2.0*rand()/RAND_MAX)-1.0);
                if (vel[i]>maxV*exp(alpha_maxV*(nxtape-ix)))
                   vel[i]=maxV*exp(alpha_maxV*(nxtape-ix));
                i=iz+(nx-1-ix)*nz+iy*nz*nx;
                vel[i]+=fminf(maxsigma, (sigma*exp(alpha_sigma*(nxtape-ix))))*((2.0*rand()/RAND_MAX)-1.0);
                if (vel[i]>maxV*exp(alpha_maxV*(nxtape-ix)))
                   vel[i]=maxV*exp(alpha_maxV*(nxtape-ix));
             }
       for (iy=0;iy<ny;iy++)
          for (ix=0;ix<nx;ix++)
             for (iz=0;iz<nztape;iz++)
             {
                /*
                dv=sigma*exp(alpha_sigma*(nztape-iz))*((2.0*rand()/RAND_MAX)-1.0);
                while (((vel[iz+ix*nz+iy*nz*nx]+dv)>maxV)||((vel[iz+ix*nz+iy*nz*nx]+dv)<minV))
		   dv=sigma*exp(alpha_sigma*(nztape-iz))*((2.0*rand()/RAND_MAX)-1.0);
	        vel[iz+ix*nz+iy*nz*nx]+=dv;

	        dv=sigma*exp(alpha_sigma*(nztape-iz))*((2.0*rand()/RAND_MAX)-1.0);
	        while (((vel[(nz-1-iz)+ix*nz+iy*nz*nx]+dv)>maxV)||((vel[(nz-1-iz)+ix*nz+iy*nz*nx]+dv)<minV))
		   dv=sigma*exp(alpha_sigma*(nztape-iz))*((2.0*rand()/RAND_MAX)-1.0);
	        vel[(nz-1-iz)+ix*nz+iy*nz*nx]+=dv;
                */
                i=iz+ix*nz+iy*nz*nx;
                vel[i]+=fminf(maxsigma, (sigma*exp(alpha_sigma*(nztape-iz))))*((2.0*rand()/RAND_MAX)-1.0);
                if (vel[i]>maxV*exp(alpha_maxV*(nztape-iz)))
                   vel[i]=maxV*exp(alpha_maxV*(nztape-iz));
                i=(nz-1-iz)+ix*nz+iy*nz*nx;
                vel[i]+=fminf(maxsigma, (sigma*exp(alpha_sigma*(nztape-iz))))*((2.0*rand()/RAND_MAX)-1.0);
                if (vel[i]>maxV*exp(alpha_maxV*(nztape-iz)))
                   vel[i]=maxV*exp(alpha_maxV*(nztape-iz));
             }

       for (i=0;i<nx*ny*nz;i++)
       {
          if (vel[i]<minV)
             vel[i]=minV;
          //if (vel[i]>maxV)
          //   vel[i]=maxV;
       } 
    }
    else if (sin==1.)
    {
       // then adjust the mean of boundary regions
       /* 
       for (iy=0;iy<nytape;iy++)
          for (ix=0;ix<nx;ix++)
             for (iz=0;iz<nz;iz++)
             {
                vel[iz+ix*nz+iy*nz*nx]*=(cos((1.0-1.0*iy/nytape)*pi)+3.0)/4.0;
                vel[iz+ix*nz+(ny-1-iy)*nz*nx]*=(cos((1.0-1.0*iy/nytape)*pi)+3.0)/4.0;
             }
    
       for (iy=0;iy<ny;iy++)
          for (ix=0;ix<nxtape;ix++)
             for (iz=0;iz<nz;iz++)
             {
                vel[iz+ix*nz+iy*nz*nx]*=(cos((1.0-1.0*ix/nxtape)*pi)+3.0)/4.0;
                vel[iz+(nx-1-ix)*nz+iy*nz*nx]*=(cos((1.0-1.0*ix/nxtape)*pi)+3.0)/4.0;
             }

       for (iy=0;iy<ny;iy++)
          for (ix=0;ix<nx;ix++)
             for (iz=0;iz<nztape;iz++)
             {
                vel[iz+ix*nz+iy*nz*nx]*=(cos((1.0-1.0*iz/nztape)*pi)+3.0)/4.0;
                vel[(nz-1-iz)+ix*nz+iy*nz*nx]*=(cos((1.0-1.0*iz/nztape)*pi)+3.0)/4.0;
             }
       */ 
       for (iy=0;iy<nytape;iy++)
          for (ix=0;ix<nx;ix++)
             for (iz=0;iz<nz;iz++)
             {
                vel[iz+ix*nz+iy*nz*nx]*=exp(-alpha_mean*(nytape-iy));
                vel[iz+ix*nz+(ny-1-iy)*nz*nx]*=exp(-alpha_mean*(nytape-iy));
             }

       for (iy=0;iy<ny;iy++)
          for (ix=0;ix<nxtape;ix++)
             for (iz=0;iz<nz;iz++)
             {
                vel[iz+ix*nz+iy*nz*nx]*=exp(-alpha_mean*(nxtape-ix));
                vel[iz+(nx-1-ix)*nz+iy*nz*nx]*=exp(-alpha_mean*(nxtape-ix));
             }

       for (iy=0;iy<ny;iy++)
          for (ix=0;ix<nx;ix++)
             for (iz=0;iz<nztape;iz++)
             {
                vel[iz+ix*nz+iy*nz*nx]*=exp(-alpha_mean*(nztape-iz));
                vel[(nz-1-iz)+ix*nz+iy*nz*nx]*=exp(-alpha_mean*(nztape-iz));
             }
       // then adjust the var of boundary regions
       for (iy=0;iy<nytape;iy++)
          for (ix=0;ix<nx;ix++)
             for (iz=0;iz<nz;iz++)
             {
                vel[iz+ix*nz+iy*nz*nx]+=0.5*sinamp*(cos((1.0-1.0*iy/nytape)*pi)-1.0)*(2.0*rand()/RAND_MAX-1.0);
                vel[iz+ix*nz+(ny-1-iy)*nz*nx]+=0.5*sinamp*(cos((1.0-1.0*iy/nytape)*pi)-1.0)*(2.0*rand()/RAND_MAX-1.0);
             }
       for (iy=0;iy<ny;iy++)
          for (ix=0;ix<nxtape;ix++)
             for (iz=0;iz<nz;iz++)
             { 
                vel[iz+ix*nz+iy*nz*nx]+=0.5*sinamp*(cos((1.0-1.0*ix/nxtape)*pi)-1.0)*(2.0*rand()/RAND_MAX-1.0);
                vel[iz+(nx-1-ix)*nz+iy*nz*nx]+=0.5*sinamp*(cos((1.0-1.0*ix/nxtape)*pi)-1.0)*(2.0*rand()/RAND_MAX-1.0);
             }
       for (iy=0;iy<ny;iy++)
          for (ix=0;ix<nx;ix++)
             for (iz=0;iz<nztape;iz++)
             {
                vel[iz+ix*nz+iy*nz*nx]+=0.5*sinamp*(cos((1.0-1.0*iz/nztape)*pi)-1.0)*(2.0*rand()/RAND_MAX-1.0);
                vel[(nz-1-iz)+ix*nz+iy*nz*nx]+=0.5*sinamp*(cos((1.0-1.0*iz/nztape)*pi)-1.0)*(2.0*rand()/RAND_MAX-1.0);
             }

       for (i=0;i<nx*ny*nz;i++)
       {
          if (vel[i]<minV)
             vel[i]=minV;
          if (vel[i]>maxV)
             vel[i]=maxV;
       } 
    }

   for (iy=nytape-1;iy>-1;iy-=j_rndbnd)
      for (ix=0;ix<nx;ix+=j_rndbnd)
         for (iz=0;iz<nz;iz+=j_rndbnd)
         {
            for (iy1=0;iy1<j_rndbnd;iy1++)
               for (ix1=0;ix1<j_rndbnd;ix1++)
                  for (iz1=0;iz1<j_rndbnd;iz1++)
                  {
                      i=iz+ix*nz+iy*nz*nx;
                      i1=iz+iz1+(ix+ix1)*nz+(iy-iy1)*nz*nx;
                      if (((iy-iy1)>-1)&&((ix+ix1)<nx)&&((iz+iz1)<nz))
                         vel[i1]=vel[i];
                      i=iz+ix*nz+(ny-1-iy)*nz*nx;
                      i1=iz+iz1+(ix+ix1)*nz+(ny-1-(iy-iy1))*nz*nx;
                      if (((iy-iy1)>-1)&&((ix+ix1)<nx)&&((iz+iz1)<nz))
                         vel[i1]=vel[i];
                  }
         }
   for (iy=0;iy<ny;iy+=j_rndbnd)
      for (ix=nxtape-1;ix>-1;ix-=j_rndbnd)
         for (iz=0;iz<nz;iz+=j_rndbnd)
         {
            for (iy1=0;iy1<j_rndbnd;iy1++)
               for (ix1=0;ix1<j_rndbnd;ix1++)
                  for (iz1=0;iz1<j_rndbnd;iz1++)
                  {
                      i=iz+ix*nz+iy*nz*nx;
                      i1=iz+iz1+(ix-ix1)*nz+(iy+iy1)*nz*nx;
                      if (((ix-ix1)>-1)&&((iy+iy1)<ny)&&((iz+iz1)<nz))
                         vel[i1]=vel[i];
                      i=iz+(nx-1-ix)*nz+iy*nz*nx;
                      i1=iz+iz1+(nx-1-(ix-ix1))*nz+(iy+iy1)*nz*nx;
                      if (((ix-ix1)>-1)&&((iy+iy1)<ny)&&((iz+iz1)<nz))
                         vel[i1]=vel[i];
                  }
         }
   for (iy=0;iy<ny;iy+=j_rndbnd)
      for (ix=0;ix<nx;ix+=j_rndbnd)
         for (iz=nztape-1;iz>-1;iz-=j_rndbnd)
         {
            for (iy1=0;iy1<j_rndbnd;iy1++)
               for (ix1=0;ix1<j_rndbnd;ix1++)
                  for (iz1=0;iz1<j_rndbnd;iz1++)
                  {
                      i=iz+ix*nz+iy*nz*nx;
                      i1=iz-iz1+(ix+ix1)*nz+(iy+iy1)*nz*nx;
                      if (((iz-iz1)>-1)&&((ix+ix1)<nx)&&((iy+iy1)<ny))
                         vel[i1]=vel[i];
                      i=(nz-1-iz)+ix*nz+iy*nz*nx;
                      i1=(nz-1-(iz-iz1))+(ix+ix1)*nz+(iy+iy1)*nz*nx;
                      if (((iz-iz1)>-1)&&((ix+ix1)<nx)&&((iy+iy1)<ny))
                         vel[i1]=vel[i];
                  }
         }


    ndim=3;
    if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
       seperr("unable to write outfile!\n");
    outfile.o[0]=oz;
    outfile.d[0]=dz;
    outfile.n[0]=nz;
    outfile.o[1]=ox;
    outfile.d[1]=dx;
    outfile.n[1]=nx;
    outfile.o[2]=oy;
    outfile.d[2]=dy;
    outfile.n[2]=ny;
    sep3d_set_sep3d(&outfile);
    if(0!=sep3dc_write_description("vel",&outfile))
       seperr("unable to output parameters for vel\n");

    if( (nz*nx*ny*4)!=srite("vel",vel,4*nz*nx*ny) )
       seperr("trouble writing out vel\n");

    return 0;
}
