#include "stdio.h"
#include "stdlib.h"

// dimensional information ( t,x,y,z, note that x,y,z info are after tapering/padding)
int   XC3dWaveprop_nt,XC3dWaveprop_nx,XC3dWaveprop_ny,XC3dWaveprop_nz;
int   XC3dWaveprop_nxtape,XC3dWaveprop_nytape,XC3dWaveprop_nztape;
float *XC3dWaveprop_veldtinvdx2;
float * XC3dWaveprop_wavet1;
float * XC3dWaveprop_wavet2;
float * XC3dWaveprop_wavet3;
float * XC3dWaveprop_tmpwv;
float *XC3dWaveprop_wvmv;
    // needwvmvin equals 1 means the waveprop operator is for forwarding modeling with recording wave movie, then recorded data/wvmv/isdep/irdep is with tapering zone
    // needwvmvin equals 2 means the waveprop operator is for waveform inversion, then recorded data/wvmv/isdep/irdep is without tapering zone
int  XC3dWaveprop_needwvmv,XC3dWaveprop_jtmv;
int  XC3dWaveprop_needdat;
int  XC3dWaveprop_freesurf;

#define Wpzxylocnopad(iz,ix,iy) ((iz)+(ix)*(XC3dWaveprop_nz-2*XC3dWaveprop_nztape)+(iy)*(XC3dWaveprop_nz-2*XC3dWaveprop_nztape)*(XC3dWaveprop_nx-2*XC3dWaveprop_nxtape))
#define Wptxylocnopad(it,ix,iy) ((it)+(ix)*XC3dWaveprop_nt+(iy)*XC3dWaveprop_nt*(XC3dWaveprop_nx-2*XC3dWaveprop_nxtape))
#define Wpxylocnopad(ix,iy) ((ix)+(iy)*(XC3dWaveprop_nx-2*XC3dWaveprop_nxtape))
#define zxylocb5(iz,ix,iy) ((iz)+(ix)*5+(iy)*5*5)
#define zxylocb3(iz,ix,iy) ((iz)+(ix)*3+(iy)*3*3)
#define Wpxzloc(iz,ix)     ((ix)+(iz)*XC3dWaveprop_nx)
#define Wpzxyloc(iz,ix,iy) ((iz)+(ix)*XC3dWaveprop_nz+(iy)*XC3dWaveprop_nz*XC3dWaveprop_nx)
#define Wptxyloc(it,ix,iy) ((it)+(ix)*XC3dWaveprop_nt+(iy)*XC3dWaveprop_nt*XC3dWaveprop_nx)
#define Wpxyloc(ix,iy) ((ix)+(iy)*XC3dWaveprop_nx)
#define WpErrmsg(str)  {fprintf(stderr,(str));return 1;}
#define max(x,y) (((x)>(y))?(x):(y))
#define min(x,y) (((x)<(y))?(x):(y))
//#define VerbMsg(str) fprintf(stderr,str);
#define WpVerbMsg(str) ;
//#define VerbMsg(str) fprintf(stderr,str);
//#define VerbMsg1(str,str1) fprintf(stderr,str,str1);
#define VerbMsg(str) ;
#define VerbMsg1(str,str1) ;

int XC3dWaveprop_Init(int ntin,  int nxin,  int nyin,  int nzin, \
                      int nxtapein, int nytapein, int nztapein,  \
                      int needwvmvin, int jtmvin, int freesurf);
//izmax_inc : incremental z range of wavefield to be calculated as t increases
int XC3dWaveprop_op0(int tsign, int *isdep, int *irdep, float *src, float *veldtinvdx2, int izmax_inc, float *data, float *wvmv );
int XC3dWaveprop_op0nobnd(int tsign, int *isdep, int *irdep, float *src, float *veldtinvdx2, int izmax_inc, float *data, float *wvmv );
int XC3dWaveprop_op(int tsign, int *isdep, int *irdep, float *src, float *veldtinvdx2, int izmax_inc, float *data, float *wvmv );
int XC3dWaveprop_op2(int tsign, int *isdep, int *irdep, float *src, float *dxinvvelinvdt2, int izmax_inc, float *data, float *wvmv );
int XC3dWaveprop_op2_rndbnd(int *isdep, int *irdep, float *src, float *veldtinvdx2, int izmax_inc, float *data, float *wvmv );
int XC3dWaveprop_setrcddat(int needdat);
int XC3dWaveprop_setwvmv(int needwvmvin);
int XC3dWaveprop_inject(int it, int *isdep, float *src);
int XC3dWaveprop_injectnopad(int it, int *isdep, float *src);
int XC3dWaveprop_rcd(int it, int *irdep, float *data);
int XC3dWaveprop_rcdnopad(int it, int *irdep, float *data);
int XC3dWaveprop_rcdmv(int it, float *wvmv);
int XC3dWaveprop_rcdmvnopad(int it, float *wvmv);
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
