#include "stdlib.h"
#include "math.h"
#include "string.h"
#include "seplib.h"
#include "sep3d.h"
#include "sep3dc.h"
#include "fftw3.h"


//############
// Fourier tranform that always perform on the first axis
//###########
int main(int argc, char** argv)
{
    fprintf(stderr,"haaha\n");
    int ndim,i,n,iw;
    int nw, nxhelix;
    float o,d;
    char temp_char[256];
    int *nin;
    float *oin, *din;
    fftwf_complex *ftin, *ftout;
    fftwf_plan plan; 
    int sign, center;
    sep3d outfile; 

    initpar(argc,argv);
   
    if(0!=sep_get_number_data_axes("in",&ndim))
       seperr("unable to get dimension from input\n");
    
    nin=(int*)malloc(sizeof(int)*ndim);
    oin=(float*)malloc(sizeof(float)*ndim);
    din=(float*)malloc(sizeof(float)*ndim);
    for(i=1;i<=ndim;i++)
    {
       if(0!=sep_get_data_axis_par("in",&i,&n,&o,&d,temp_char))
       seperr("unable to get parameters from input!\n");
       nin[i-1]=n;
       oin[i-1]=o;
       din[i-1]=d;
    }

    // readin parameters
    if (0==getch("center","i", &center)) center=0;
    if (0==getch("sign","i", &sign)) sign=1;

    nw=nin[0];
    fprintf(stderr,"nw=%d\n",nw);
    ftin=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nw);
    ftout=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nw);
  
    if (sign==-1)
       plan = fftwf_plan_dft_1d(nw, ftin, ftout, FFTW_FORWARD, FFTW_ESTIMATE);
    else if (sign==1)
       plan = fftwf_plan_dft_1d(nw, ftin, ftout, FFTW_BACKWARD, FFTW_ESTIMATE);
    else
      seperr("Error! sign should either be 1 or -1!\n");

    nxhelix=1;
    for (i=1;i<ndim;i++)
       nxhelix*=nin[i];

    if(0!=init_sep3d_par(&outfile,"OUTPUT","COMPLEX","REGULAR",ndim,0))
       seperr("unable to write outfile!\n");

     
    outfile.o[0]=0.;
    outfile.d[0]=1./(nin[0]*din[0]);
    outfile.n[0]=nin[0];

    for (i=1;i<ndim;i++)
    {
       outfile.o[i]=oin[i];
       outfile.d[i]=din[i];
       outfile.n[i]=nin[i];
    }

    sep3d_set_sep3d(&outfile);
    if(0!=sep3dc_write_description("out",&outfile))
       seperr("unable to output parameters for output\n");

    for (i=0;i<nxhelix;i++)
    {
       if ((nw*8)!=sreed("in",ftin,nw*8))
          fprintf(stderr,"Error read in ft trace of size %d \n", nw*8);
      
       if (center==1)
          for (iw=1;iw<nw;iw+=2)
          {
             ftin[iw][0]*=-1;
             ftin[iw][1]*=-1;
          }

       fftwf_execute(plan);
    
       if (center==-1)
          for (iw=1;iw<nw;iw+=2)
          {
             ftout[iw][0]*=-1;
             ftout[iw][1]*=-1;
          }

       if( (nw*8)!=srite("out",ftout,8*nw) )
             seperr("trouble writing out ftout\n");
    }
    
    fftwf_destroy_plan(plan);
    fftwf_free(ftin); fftwf_free(ftout);

    return 0;
}
